(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@angular/platform-browser'), require('@angular/forms'), require('@angular/platform-browser/animations'), require('@angular/material'), require('angular-font-awesome'), require('@angular/animations'), require('moment'), require('ngx-perfect-scrollbar'), require('ngx-owl-carousel'), require('ng2-charts')) :
    typeof define === 'function' && define.amd ? define('ngx-utilitario-rclt', ['exports', '@angular/core', '@angular/common', '@angular/platform-browser', '@angular/forms', '@angular/platform-browser/animations', '@angular/material', 'angular-font-awesome', '@angular/animations', 'moment', 'ngx-perfect-scrollbar', 'ngx-owl-carousel', 'ng2-charts'], factory) :
    (global = global || self, factory(global['ngx-utilitario-rclt'] = {}, global.ng.core, global.ng.common, global.ng.platformBrowser, global.ng.forms, global.ng.platformBrowser.animations, global.ng.material, global['angular-font-awesome'], global.ng.animations, global.moment, global['ngx-perfect-scrollbar'], global.ngxOwlCarousel, global.ng2Charts));
}(this, function (exports, core, common, platformBrowser, forms, animations, material, angularFontAwesome, animations$1, _moment, ngxPerfectScrollbar, ngxOwlCarousel, ng2Charts) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Input con material
     */
    var InputComponent = /** @class */ (function () {
        /**
         * Crearemos un formGroup por defecto en caso no se envie
         */
        function InputComponent(formBuilder) {
            this.formBuilder = formBuilder;
            /**
             * Apariencia de material del input
             */
            this.appearance = 'outline';
            /**
             * padre del input
             */
            this.parent = new forms.FormGroup({});
            /**
             * padre del input
             */
            this.name = 'default';
            /**
             * tooltip a mostrar
             */
            this.tooltip = '';
            /**
             * position del tooltip
             */
            this.position = 'above';
            /**
             * texto abajo del input
             */
            this.hint = '';
            /**
             * label en el input
             */
            this.label = '';
            /**
             * Icono  en la parte final del textbox
             */
            this.iconMatSuffix = '';
            /**
             * texto en la parte final del textbox
             */
            this.spanMatSuffix = '';
            /**
             * Icono  en la parte inicial del textbox
             */
            this.iconMatPrefix = '';
            /**
             * texto en la parte inicial del textbox
             */
            this.spanMatPrefix = '';
            /**
             * evento keydown emita un evnto
             */
            this.keydown = new core.EventEmitter();
            /**
             * evento que retorna el valor del input
             */
            this.value = new core.EventEmitter();
            this.parent = this.formBuilder.group({
                default: ''
            });
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        InputComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Validacion de que los elementos no sean null undefined o vacios
         */
        /**
         * Validacion de que los elementos no sean null undefined o vacios
         * @param {?} element
         * @return {?}
         */
        InputComponent.prototype.validationValue = /**
         * Validacion de que los elementos no sean null undefined o vacios
         * @param {?} element
         * @return {?}
         */
        function (element) {
            if (element !== undefined && element !== null && element !== '') {
                return true;
            }
            return false;
        };
        /**
         * Retornamos un nuevo evento y llamamos a la funcion emitValue
         * @param event Evento al presionar una tecla
         */
        /**
         * Retornamos un nuevo evento y llamamos a la funcion emitValue
         * @param {?} event Evento al presionar una tecla
         * @return {?}
         */
        InputComponent.prototype.keydownFun = /**
         * Retornamos un nuevo evento y llamamos a la funcion emitValue
         * @param {?} event Evento al presionar una tecla
         * @return {?}
         */
        function (event) {
            this.keydown.emit(event);
            this.emitValue();
        };
        /**
         * Emitimos un evento retornando el valor actual del input
         */
        /**
         * Emitimos un evento retornando el valor actual del input
         * @return {?}
         */
        InputComponent.prototype.emitValue = /**
         * Emitimos un evento retornando el valor actual del input
         * @return {?}
         */
        function () {
            this.value.emit(this.parent.controls[this.name].value);
        };
        InputComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-input',
                        template: "<div [formGroup]=\"parent\" class=\"w-100\">\r\n  <mat-form-field class=\"w-100\" [appearance]=\"appearance\" [matTooltip]=\"tooltip\" [matTooltipPosition]=\"position\" >\r\n    <mat-label *ngIf=\"validationValue(label)\">{{label}}</mat-label>\r\n    <input matInput (keyup)=\"keydownFun($event)\" formControlName=\"{{name}}\" >\r\n    <em *ngIf=\"validationValue(iconMatPrefix)\" [ngClass]=\"iconMatPrefix\" matPrefix></em>\r\n    <span *ngIf=\"validationValue(spanMatPrefix)\" matPrefix>spanMatPrefix</span>\r\n    <em *ngIf=\"validationValue(iconMatSuffix)\" [ngClass]=\"iconMatSuffix\" matSuffix></em>\r\n    <span *ngIf=\"validationValue(spanMatSuffix)\" matSuffix>spanMatSuffix</span>\r\n    <mat-hint *ngIf=\"validationValue(hint)\">{{hint}}</mat-hint>\r\n  </mat-form-field>\r\n</div>\r\n",
                        styles: ["::ng-deep .mat-form-field-flex>.mat-form-field-infix{padding:.6em 0!important}::ng-deep .mat-form-field-label-wrapper{top:-1.2em;color:rgba(0,0,0,.5)}::ng-deep .mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{-webkit-transform:translateY(-1.3em) scale(.7);transform:translateY(-1.3em) scale(.7);width:133.33333%}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline{background-color:#fff;border-radius:.3rem}::ng-deep .mat-form-field-appearance-outline .mat-form-field-prefix,::ng-deep .mat-form-field-appearance-outline .mat-form-field-suffix{top:-.15em!important;padding:0 .8rem}"]
                    }] }
        ];
        /** @nocollapse */
        InputComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        InputComponent.propDecorators = {
            appearance: [{ type: core.Input }],
            parent: [{ type: core.Input }],
            name: [{ type: core.Input }],
            tooltip: [{ type: core.Input }],
            position: [{ type: core.Input }],
            hint: [{ type: core.Input }],
            label: [{ type: core.Input }],
            iconMatSuffix: [{ type: core.Input }],
            spanMatSuffix: [{ type: core.Input }],
            iconMatPrefix: [{ type: core.Input }],
            spanMatPrefix: [{ type: core.Input }],
            keydown: [{ type: core.Output }],
            value: [{ type: core.Output }]
        };
        return InputComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Input con autocomplete definido
     */
    var InputSearchComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function InputSearchComponent() {
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        InputSearchComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        InputSearchComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-input-search',
                        template: "<p>\n  input-search works!\n</p>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        InputSearchComponent.ctorParameters = function () { return []; };
        return InputSearchComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioFormstModule = /** @class */ (function () {
        function NgxUtilitarioFormstModule() {
        }
        NgxUtilitarioFormstModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [InputComponent, InputSearchComponent],
                        imports: [
                            forms.ReactiveFormsModule,
                            common.CommonModule,
                            material.MatFormFieldModule,
                            material.MatInputModule,
                            material.MatTooltipModule
                        ],
                        exports: [
                            InputComponent,
                            InputSearchComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioFormstModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Servicio que añade un componente en tiempo de ejecucion
     */
    var DynamicComponentService = /** @class */ (function () {
        /**
         * @ignore
         */
        function DynamicComponentService(injector, resolver, appRef) {
            this.injector = injector;
            this.resolver = resolver;
            this.appRef = appRef;
        }
        /**
         * Servicio que permite injectar componente en tiempo de ejecucion
         * @example
         * this.dynamicComponentService.injectComponent(PopupComponent,
         *        x => { x.tipo = currentFeature.properties.marcador ; x.id = currentFeature.properties.id; }  );
         * @param component El componente a insertar
         * @param propertySetter Las propiedades del componente que va a recibir
         */
        /**
         * Servicio que permite injectar componente en tiempo de ejecucion
         * \@example
         * this.dynamicComponentService.injectComponent(PopupComponent,
         *        x => { x.tipo = currentFeature.properties.marcador ; x.id = currentFeature.properties.id; }  );
         * @template T
         * @param {?} component El componente a insertar
         * @param {?=} propertySetter Las propiedades del componente que va a recibir
         * @return {?}
         */
        DynamicComponentService.prototype.injectComponent = /**
         * Servicio que permite injectar componente en tiempo de ejecucion
         * \@example
         * this.dynamicComponentService.injectComponent(PopupComponent,
         *        x => { x.tipo = currentFeature.properties.marcador ; x.id = currentFeature.properties.id; }  );
         * @template T
         * @param {?} component El componente a insertar
         * @param {?=} propertySetter Las propiedades del componente que va a recibir
         * @return {?}
         */
        function (component, propertySetter) {
            // Elimina el componente si este ya existe
            if (this.compRef) {
                this.compRef.destroy();
            }
            // Resuelve el componente y lo crea
            /** @type {?} */
            var compFactory = this.resolver.resolveComponentFactory(component);
            this.compRef = compFactory.create(this.injector);
            // Pasa las nuevas propiedades al componente
            if (propertySetter) {
                propertySetter(this.compRef.instance);
            }
            // Attach to Application
            this.appRef.attachView(this.compRef.hostView);
            // Creamos un div y añadimos el component
            /** @type {?} */
            var div = document.createElement('div');
            div.appendChild(this.compRef.location.nativeElement);
            // Retornamos la referencia del componetent
            return div;
        };
        /**
         * Retornamos el componente
         */
        /**
         * Retornamos el componente
         * @return {?}
         */
        DynamicComponentService.prototype.getCompoRef = /**
         * Retornamos el componente
         * @return {?}
         */
        function () {
            return this.compRef;
        };
        DynamicComponentService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        DynamicComponentService.ctorParameters = function () { return [
            { type: core.Injector },
            { type: core.ComponentFactoryResolver },
            { type: core.ApplicationRef }
        ]; };
        /** @nocollapse */ DynamicComponentService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function DynamicComponentService_Factory() { return new DynamicComponentService(core.ɵɵinject(core.INJECTOR), core.ɵɵinject(core.ComponentFactoryResolver), core.ɵɵinject(core.ApplicationRef)); }, token: DynamicComponentService, providedIn: "root" });
        return DynamicComponentService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo dynamic el cual contiene el servicio para añadir un componente en tiempo de ejecucion
     */
    var NgxUtilitarioDynamicModule = /** @class */ (function () {
        function NgxUtilitarioDynamicModule() {
        }
        NgxUtilitarioDynamicModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [
                            common.CommonModule
                        ],
                        providers: [
                            DynamicComponentService
                        ]
                    },] }
        ];
        return NgxUtilitarioDynamicModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que nos permite repetir un icono n vces y activar los primeros iconos
     */
    var RepeatIconComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function RepeatIconComponent() {
            /**
             * Cantidad de veces a repetir el icono
             */
            this.repetir = 5;
            /**
             * Cantidad de iconos a activar
             */
            this.activo = 0;
            /**
             * Icono a mostrar utilizo font-awesome
             */
            this.icono = 'fa fa-user';
            /**
             * Color del icono normalmente por defecto es #000
             */
            this.color = '#000';
            /**
             * COlor del icono activo por defecto es #000
             */
            this.colorActivo = '#000';
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        RepeatIconComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        RepeatIconComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-repeat-icon',
                        template: "<ng-container class=\"repetirIcono\">\n  <em *ngFor=\"let item of activo | numberToArray\" class=\"{{icono}}\" [style.color]=\"colorActivo\"></em>\n  <em *ngFor=\"let item of (repetir - activo) | numberToArray\" class=\"{{icono}}\" [style.color]=\"color\"></em>\n</ng-container>",
                        styles: [".repetirIcono{display:inline-flex}"]
                    }] }
        ];
        /** @nocollapse */
        RepeatIconComponent.ctorParameters = function () { return []; };
        RepeatIconComponent.propDecorators = {
            repetir: [{ type: core.Input }],
            activo: [{ type: core.Input }],
            icono: [{ type: core.Input }],
            color: [{ type: core.Input }],
            colorActivo: [{ type: core.Input }]
        };
        return RepeatIconComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Inserta un span con clase search-highlight en la palabra resaltada
     * si desea cambiar este estilo utilizar "::ng-deep search-highlight"
     */
    var HighlightPipe = /** @class */ (function () {
        function HighlightPipe() {
        }
        /**
         * Añade un span entre el texto para añadirle efectos
         * @param text Texto completo
         * @param search Texto a buscar
         */
        /**
         * Añade un span entre el texto para añadirle efectos
         * @param {?} text Texto completo
         * @param {?} search Texto a buscar
         * @return {?}
         */
        HighlightPipe.prototype.transform = /**
         * Añade un span entre el texto para añadirle efectos
         * @param {?} text Texto completo
         * @param {?} search Texto a buscar
         * @return {?}
         */
        function (text, search) {
            if (search && text) {
                /** @type {?} */
                var pattern = search.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
                pattern = pattern.split(' ').filter((/**
                 * @param {?} t
                 * @return {?}
                 */
                function (t) {
                    return t.length > 0;
                })).join('|');
                /** @type {?} */
                var regex = new RegExp(pattern, 'gi');
                return text.replace(regex, (/**
                 * @param {?} match
                 * @return {?}
                 */
                function (match) { return "<span class=\"search-highlight\">" + match + "</span>"; }));
            }
            else {
                return text;
            }
        };
        HighlightPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'highlight'
                    },] }
        ];
        return HighlightPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Crea un arreglo de tamaño n
     */
    var NumberToArrayPipe = /** @class */ (function () {
        function NumberToArrayPipe() {
        }
        /**
         * crea un arreglo de tamaño n
         *
         * @example
         * *ngFor="let item of 2 | numberToArray"
         *
         * @param length tamaño del nuevo arreglo
         *
         * @returns un arreglo de tamaño n
         */
        /**
         * crea un arreglo de tamaño n
         *
         * \@example
         * *ngFor="let item of 2 | numberToArray"
         *
         * @param {?} length tamaño del nuevo arreglo
         *
         * @return {?} un arreglo de tamaño n
         */
        NumberToArrayPipe.prototype.transform = /**
         * crea un arreglo de tamaño n
         *
         * \@example
         * *ngFor="let item of 2 | numberToArray"
         *
         * @param {?} length tamaño del nuevo arreglo
         *
         * @return {?} un arreglo de tamaño n
         */
        function (length) {
            /** @type {?} */
            var res = [];
            for (var i = 0; i < length; i++) {
                res.push(i);
            }
            return res;
        };
        NumberToArrayPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'numberToArray'
                    },] }
        ];
        return NumberToArrayPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioPipesModule = /** @class */ (function () {
        function NgxUtilitarioPipesModule() {
        }
        NgxUtilitarioPipesModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [HighlightPipe, NumberToArrayPipe],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [
                            HighlightPipe,
                            NumberToArrayPipe
                        ]
                    },] }
        ];
        return NgxUtilitarioPipesModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo en el cual se trabajara sobre iconos
     */
    var NgxUtilitarioIconsModule = /** @class */ (function () {
        function NgxUtilitarioIconsModule() {
        }
        NgxUtilitarioIconsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [RepeatIconComponent],
                        imports: [
                            common.CommonModule,
                            NgxUtilitarioPipesModule
                        ],
                        exports: [RepeatIconComponent]
                    },] }
        ];
        return NgxUtilitarioIconsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Servicio que permite añadir modales
     */
    var ModalService = /** @class */ (function () {
        /**
         * @ignore
         */
        function ModalService() {
            /**
             * Modales registrados en el servicio
             */
            this.modals = [];
        }
        /**
         * Añadimos el modal a la lista de modales a mostrar
         * @param modal Modal a mostrar
         */
        /**
         * Añadimos el modal a la lista de modales a mostrar
         * @param {?} modal Modal a mostrar
         * @return {?}
         */
        ModalService.prototype.add = /**
         * Añadimos el modal a la lista de modales a mostrar
         * @param {?} modal Modal a mostrar
         * @return {?}
         */
        function (modal) {
            this.modals.push(modal);
        };
        /**
         * Eliminamos un modal de la lista de modales a mostrar
         * @param id id del model que vamos a eliminar
         */
        /**
         * Eliminamos un modal de la lista de modales a mostrar
         * @param {?} id id del model que vamos a eliminar
         * @return {?}
         */
        ModalService.prototype.remove = /**
         * Eliminamos un modal de la lista de modales a mostrar
         * @param {?} id id del model que vamos a eliminar
         * @return {?}
         */
        function (id) {
            this.modals = this.modals.filter((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.id !== id; }));
        };
        /**
         * Abrir un modal
         * @param id id del modal que queremos mostrar
         */
        /**
         * Abrir un modal
         * @param {?} id id del modal que queremos mostrar
         * @return {?}
         */
        ModalService.prototype.open = /**
         * Abrir un modal
         * @param {?} id id del modal que queremos mostrar
         * @return {?}
         */
        function (id) {
            /** @type {?} */
            var modal = this.modals.filter((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.id === id; }))[0];
            modal.open();
        };
        /**
         * Cerrar un modal
         * @param id id del modal que queremos ocultar
         */
        /**
         * Cerrar un modal
         * @param {?} id id del modal que queremos ocultar
         * @return {?}
         */
        ModalService.prototype.close = /**
         * Cerrar un modal
         * @param {?} id id del modal que queremos ocultar
         * @return {?}
         */
        function (id) {
            /** @type {?} */
            var modal = this.modals.filter((/**
             * @param {?} x
             * @return {?}
             */
            function (x) { return x.id === id; }))[0];
            modal.close();
        };
        ModalService.decorators = [
            { type: core.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ModalService.ctorParameters = function () { return []; };
        /** @nocollapse */ ModalService.ngInjectableDef = core.ɵɵdefineInjectable({ factory: function ModalService_Factory() { return new ModalService(); }, token: ModalService, providedIn: "root" });
        return ModalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Abre el nuevo componente enuna ventana emergente con una animacion de oppocity
     */
    var ModalComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ModalComponent(modalService, el, renderer, document) {
            this.modalService = modalService;
            this.el = el;
            this.renderer = renderer;
            /**
             * variable por la cual asignamos la animacion al modal
             */
            this.openclose = 'closed';
            this.document = (/** @type {?} */ (document));
            this.element = el.nativeElement;
        }
        /**
         * Al inicializar el componente validamos si tiene un id, lo añadimos al html, y le asignamos una accion de cerrar
         */
        /**
         * Al inicializar el componente validamos si tiene un id, lo añadimos al html, y le asignamos una accion de cerrar
         * @return {?}
         */
        ModalComponent.prototype.ngOnInit = /**
         * Al inicializar el componente validamos si tiene un id, lo añadimos al html, y le asignamos una accion de cerrar
         * @return {?}
         */
        function () {
            /** @type {?} */
            var modal = this;
            // Validamos si tiene el atributo id
            if (!this.id) {
                console.error('modal must have an id');
                return;
            }
            // añadimos el modal despues </body>) para que se pueda mostrar sobre todos los elementos
            this.document.body.appendChild(this.element);
            // cerrar modal
            this.element.addEventListener('click', (/**
             * @param {?} e
             * @return {?}
             */
            function (e) {
                if (e.target.className === 'ngx-utilitario-modal') {
                    modal.close();
                }
            }));
            // add self (this modal instance) to the modal service so it's accessible from controllers
            this.modalService.add(this);
            this.close();
        };
        /**
         * Se elimina del modal service cuando el componente es destruido
         */
        /**
         * Se elimina del modal service cuando el componente es destruido
         * @return {?}
         */
        ModalComponent.prototype.ngOnDestroy = /**
         * Se elimina del modal service cuando el componente es destruido
         * @return {?}
         */
        function () {
            this.modalService.remove(this.id);
            this.element.remove();
        };
        /**
         * abrimos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display block y le asignamos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         */
        /**
         * abrimos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display block y le asignamos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         * @return {?}
         */
        ModalComponent.prototype.open = /**
         * abrimos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display block y le asignamos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         * @return {?}
         */
        function () {
            this.openclose = 'open';
            this.element.style.display = 'block';
            this.renderer.addClass(this.document.body, 'ngx-utilitario-modal-open');
            // this.renderer.setStyle(document.body, 'overflow','hidden');
        };
        /**
         * Cerramos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display none y le removemos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         */
        /**
         * Cerramos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display none y le removemos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         * @return {?}
         */
        ModalComponent.prototype.close = /**
         * Cerramos el modal
         * Cambiamos la variable de la animacion
         * le aplicamos el estilo display none y le removemos la
         * clase ngx-utilitario-modal-open que permite visualizar el componente
         * @return {?}
         */
        function () {
            this.openclose = 'closed';
            this.element.style.display = 'none';
            this.renderer.removeClass(this.document.body, 'ngx-utilitario-modal-open');
            // this.renderer.setStyle(document.body, 'overflow', 'auto' )
        };
        ModalComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-modal',
                        template: "<div class=\"ngx-utilitario-modal\">\r\n  <div class=\"ngx-utilitario-modal-body\">\r\n    <div class=\"ngx-utilitario-modal-content\">\r\n      <div style=\"position: relative;\">\r\n        <button type=\"button\" class=\"ngx-utilitario-modal-cerrar\" (click)=\"close()\">\r\n          <span aria-hidden=\"true\">&times;</span>\r\n        </button>\r\n        <div class=\"ngx-utilitario-modal-ngcontent\" [@openClose]=\"openclose\">\r\n          <ng-content>\r\n          </ng-content>\r\n        </div>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>\r\n<div class=\"ngx-utilitario-modal-background\" [@openCloseBackground]=\"openclose\"></div>\r\n<div class=\"ngx-utilitario-modal-open\"></div>",
                        encapsulation: core.ViewEncapsulation.None,
                        animations: [
                            animations$1.trigger('openClose', [
                                // ...
                                animations$1.state('open', animations$1.style({
                                    opacity: 1
                                })),
                                animations$1.state('closed', animations$1.style({
                                    opacity: 0
                                    // height: '0px',
                                    // width: '0px',
                                })),
                                animations$1.transition('open => closed', [
                                    animations$1.animate('0.35s')
                                ]),
                                animations$1.transition('closed => open', [
                                    animations$1.animate('0.35s')
                                ]),
                            ]),
                            animations$1.trigger('openCloseBackground', [
                                // ...
                                animations$1.state('closed', animations$1.style({
                                    // top: '50%',
                                    // right: '50%',
                                    // bottom: '49%',
                                    // left: '49%'
                                    opacity: 0
                                })),
                                animations$1.state('open', animations$1.style({
                                    // top: '0',
                                    // right: '0',
                                    // bottom: '0',
                                    // left: '0'
                                    opacity: 0.7
                                })),
                                animations$1.transition('open => closed', [
                                    animations$1.animate('0.35s')
                                ]),
                                animations$1.transition('closed => open', [
                                    animations$1.animate('0.35s')
                                ]),
                            ])
                        ],
                        styles: [".ngx-utilitario-modal{display:table;position:fixed;top:0;left:0;margin:15px 0 0;padding:0;height:100%;width:100%;z-index:1000}.ngx-utilitario-modal .ngx-utilitario-modal-body{display:table-cell;vertical-align:middle;padding:0;margin:0;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;height:-webkit-fit-content;height:-moz-fit-content;height:fit-content}.ngx-utilitario-modal .ngx-utilitario-modal-content{background:#fff;margin:0 auto;width:-webkit-fit-content;width:-moz-fit-content;width:fit-content;height:-webkit-fit-content;height:-moz-fit-content;height:fit-content;max-height:100%;padding:15px}.ngx-utilitario-modal .ngx-utilitario-modal-content .ngx-utilitario-modal-cerrar{opacity:1;font-size:18px;position:absolute;top:-30px;right:-30px;width:30px;height:30px;background-color:#fff;border-radius:100%;-moz-border-radius:100%;box-shadow:0 1px 2px rgba(0,0,0,.2);padding:0;z-index:901}.ngx-utilitario-modal .ngx-utilitario-modal-content .ngx-utilitario-modal-ngcontent{overflow-y:auto;max-height:-webkit-fill-available}.ngx-utilitario-modal-background{position:fixed;top:0;right:0;bottom:0;left:0;background-color:#000;opacity:.75;z-index:900;-webkit-animation-delay:2s;animation-delay:2s;-webkit-animation-duration:4s;animation-duration:4s;animation-direction:reverse}.ngx-utilitario-modal-open{overflow:hidden!important}"]
                    }] }
        ];
        /** @nocollapse */
        ModalComponent.ctorParameters = function () { return [
            { type: ModalService },
            { type: core.ElementRef },
            { type: core.Renderer2 },
            { type: undefined, decorators: [{ type: core.Inject, args: [common.DOCUMENT,] }] }
        ]; };
        ModalComponent.propDecorators = {
            id: [{ type: core.Input }]
        };
        return ModalComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo en el cual se trabajara los modales de la libreria
     */
    var NgxUtilitarioModalModule = /** @class */ (function () {
        function NgxUtilitarioModalModule() {
        }
        NgxUtilitarioModalModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [ModalComponent],
                        imports: [
                            common.CommonModule
                        ]
                    },] }
        ];
        return NgxUtilitarioModalModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Chat component por el cual mostramos una lista de chat y una conversacion
     */
    var ChatComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatComponent() {
            /**
             * Lista de conversaciones a mostrar
             */
            this.list = [];
            /**
             * Conversacion actual a mostrar puede no estar en la lista
             */
            this.chatDetail = undefined;
            /**
             * Se envia un evento si se escribio un nuevo mensaje
             */
            this.messageNew = new core.EventEmitter();
            /**
             * Si hace click en una conversacion de la lista
             */
            this.listClick = new core.EventEmitter();
            /**
             * Si elimina la conversacion
             */
            this.chatDelete = new core.EventEmitter();
            /**
             * Si bloquea una conversacion
             */
            this.chatLock = new core.EventEmitter();
            /**
             * Variable en la cual se guardara la lista ingresada o la de busqueda
             */
            this.finalList = [];
            /**
             * Variable en la cual se guardara la lista de busqueda
             */
            this.searchList = [];
            /**
             * Flag que nos dira si hay una busqueda o no
             */
            this.searchFlag = false;
            /**
             * Texto a buscar
             */
            this.searchText = '';
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        ChatComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
            this.searchValidate(this.list);
        };
        /**
         * 1.- si el chat que se esta mostrando a cambiado sus mensajes
         * 2.- si existe una lista de busqued
         * @param changes Si cambia algun item de la lista se actualizara
         */
        /**
         * 1.- si el chat que se esta mostrando a cambiado sus mensajes
         * 2.- si existe una lista de busqued
         * @param {?} changes Si cambia algun item de la lista se actualizara
         * @return {?}
         */
        ChatComponent.prototype.ngOnChanges = /**
         * 1.- si el chat que se esta mostrando a cambiado sus mensajes
         * 2.- si existe una lista de busqued
         * @param {?} changes Si cambia algun item de la lista se actualizara
         * @return {?}
         */
        function (changes) {
            var _this = this;
            if (changes.list) {
                this.list.forEach((/**
                 * @param {?} chat
                 * @return {?}
                 */
                function (chat) {
                    if (_this.chatDetail) {
                        if (chat.id === _this.chatDetail.id) {
                            _this.chatDetail.messages = chat.message;
                            _this.chatDetail.lock = chat.lock;
                        }
                    }
                }));
                this.searchValidate(changes.list.currentValue);
            }
        };
        /**
         * Si hay una busqueda activa no se actualiza la lista
         */
        /**
         * Si hay una busqueda activa no se actualiza la lista
         * @param {?} chatListDetail
         * @return {?}
         */
        ChatComponent.prototype.searchValidate = /**
         * Si hay una busqueda activa no se actualiza la lista
         * @param {?} chatListDetail
         * @return {?}
         */
        function (chatListDetail) {
            if (!this.searchFlag) {
                this.finalList = chatListDetail;
                console.log('ingrese', this.finalList);
            }
            else {
                this.finalList = this.searchList;
                console.log('ingrese searc', this.finalList);
            }
        };
        /**
         * Si realiza un click en un item de la lista del chat cambiamos la conversacion
         * y emitimos un evento
         * @param detalle propiedades de la conversacion
         */
        /**
         * Si realiza un click en un item de la lista del chat cambiamos la conversacion
         * y emitimos un evento
         * @param {?} detalle propiedades de la conversacion
         * @return {?}
         */
        ChatComponent.prototype.listDetailClick = /**
         * Si realiza un click en un item de la lista del chat cambiamos la conversacion
         * y emitimos un evento
         * @param {?} detalle propiedades de la conversacion
         * @return {?}
         */
        function (detalle) {
            this.listClick.emit(detalle);
            this.changeDetail(detalle);
        };
        /**
         * Cambiamos conversacion actual y muestra la conversacion que tiene la lista por el usuario
         * @param detalle  propiedades de la conversacion
         */
        /**
         * Cambiamos conversacion actual y muestra la conversacion que tiene la lista por el usuario
         * @param {?} detail
         * @return {?}
         */
        ChatComponent.prototype.changeDetail = /**
         * Cambiamos conversacion actual y muestra la conversacion que tiene la lista por el usuario
         * @param {?} detail
         * @return {?}
         */
        function (detail) {
            /** @type {?} */
            var listTem = this.list.filter((/**
             * @param {?} list
             * @return {?}
             */
            function (list) { return list.id === detail.id; }))[0];
            this.chatDetail = {
                state: listTem.state,
                name: listTem.name,
                id: listTem.id,
                messages: listTem.message,
                img: listTem.img,
                lock: listTem.lock
            };
            this.moveToMessageIndex = this.moveToMessageIndexTem;
        };
        /**
         * Cuando el usuario envie un mensaje añadimos propiedad a la lista y realizamos un push
         * @param mensaje propiedades del mensaje enviado
         */
        /**
         * Cuando el usuario envie un mensaje añadimos propiedad a la lista y realizamos un push
         * @param {?} mensaje propiedades del mensaje enviado
         * @return {?}
         */
        ChatComponent.prototype.messageSend = /**
         * Cuando el usuario envie un mensaje añadimos propiedad a la lista y realizamos un push
         * @param {?} mensaje propiedades del mensaje enviado
         * @return {?}
         */
        function (mensaje) {
            this.moveToMessageIndex = undefined;
            this.chatDetail.messages.push(mensaje);
            this.messageNew.emit(mensaje);
        };
        /**
         * Al eliminar mensajes emitiremos un evento y limpiaremos elementos
         */
        /**
         * Al eliminar mensajes emitiremos un evento y limpiaremos elementos
         * @return {?}
         */
        ChatComponent.prototype.messageDelete = /**
         * Al eliminar mensajes emitiremos un evento y limpiaremos elementos
         * @return {?}
         */
        function () {
            this.chatDetail.messages = [];
            this.chatDelete.emit(this.chatDetail);
        };
        /**
         * Accion de bloquear chat
         * @param estadoBloqueo los estados pueden ser desbloqueado, bloqueado, bloqueo
         */
        /**
         * Accion de bloquear chat
         * @param {?} estadoBloqueo los estados pueden ser desbloqueado, bloqueado, bloqueo
         * @return {?}
         */
        ChatComponent.prototype.chatLocking = /**
         * Accion de bloquear chat
         * @param {?} estadoBloqueo los estados pueden ser desbloqueado, bloqueado, bloqueo
         * @return {?}
         */
        function (estadoBloqueo) {
            this.chatDetail.lock = estadoBloqueo;
            this.chatLock.emit(this.chatDetail);
        };
        /**
         * Comprobar si debe realizar una busqueda o no
         */
        /**
         * Comprobar si debe realizar una busqueda o no
         * @param {?} text
         * @return {?}
         */
        ChatComponent.prototype.searchChange = /**
         * Comprobar si debe realizar una busqueda o no
         * @param {?} text
         * @return {?}
         */
        function (text) {
            this.moveToMessageIndexTem = undefined;
            this.searchText = text;
            this.searchListClean();
            if (text.length > 0) {
                this.searchFlag = true;
                this.searchChatName(text);
                this.searchChatMessage(text);
            }
            else {
                this.searchFlag = false;
            }
            this.searchValidate(this.list);
        };
        /**
         * Buscamos en la lista actual en los nombres del chat
         * @param text palabra a buscar
         */
        /**
         * Buscamos en la lista actual en los nombres del chat
         * @param {?} text palabra a buscar
         * @return {?}
         */
        ChatComponent.prototype.searchChatName = /**
         * Buscamos en la lista actual en los nombres del chat
         * @param {?} text palabra a buscar
         * @return {?}
         */
        function (text) {
            var _this = this;
            this.list.forEach((/**
             * @param {?} chat
             * @return {?}
             */
            function (chat) {
                if (chat.name.includes(text)) {
                    _this.searchList.push(chat);
                }
            }));
        };
        /**
         * Buscamos en la lista actual los mensajes del chat y cambiamos el ultimo chat por el chat encontrado
         * @param text palabra a buscar
         */
        /**
         * Buscamos en la lista actual los mensajes del chat y cambiamos el ultimo chat por el chat encontrado
         * @param {?} text palabra a buscar
         * @return {?}
         */
        ChatComponent.prototype.searchChatMessage = /**
         * Buscamos en la lista actual los mensajes del chat y cambiamos el ultimo chat por el chat encontrado
         * @param {?} text palabra a buscar
         * @return {?}
         */
        function (text) {
            var _this = this;
            this.list.forEach((/**
             * @param {?} chat
             * @return {?}
             */
            function (chat) {
                // ya que necesitamos el index
                // tslint:disable-next-line: prefer-for-of
                for (var i = 0; i < chat.message.length; i++) {
                    if (chat.message[i].message.includes(text)) {
                        _this.moveToMessageIndexTem = i;
                        _this.searchList.push({
                            id: chat.id,
                            img: chat.img,
                            lock: chat.lock,
                            message: [chat.message[i]],
                            name: chat.name,
                            notification: chat.notification,
                            state: chat.state
                        });
                        break;
                    }
                }
            }));
        };
        /**
         * Limpiamos la lista de busqueda
         */
        /**
         * Limpiamos la lista de busqueda
         * @return {?}
         */
        ChatComponent.prototype.searchListClean = /**
         * Limpiamos la lista de busqueda
         * @return {?}
         */
        function () {
            this.searchList = [];
        };
        ChatComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat',
                        template: "<div class=\"container-fluid row-no-padding ngx-utilitario-chat\">\r\n  <div class=\"row\">\r\n    <div class=\"col-md-4 col-sm-12 ngx-utilitario-chat-list\">\r\n      <header class=\"ngx-util-list-header\">\r\n        Chats\r\n        <span class=\"fa fa-pencil-square-o\"></span>\r\n      </header>\r\n      <ngx-utilitario-chat-search class=\"ngx-util-list-search\" (searchChange)=\"searchChange($event)\">\r\n      </ngx-utilitario-chat-search>\r\n      <ngx-utilitario-chat-list class=\"ngx-util-list-detail\" [list]=\"finalList\" (clickList)=\"listDetailClick($event)\"\r\n        [search]=\"searchText\">\r\n      </ngx-utilitario-chat-list>\r\n    </div>\r\n    <div class=\"col-md-8 col-sm-12\">\r\n      <ngx-utilitario-chat-detail [chatDetail]=\"chatDetail\" [moveToMessage]=\"moveToMessageIndex\"\r\n        (newMessage)=\"messageSend($event)\" (deleteMessages)=\"messageDelete()\" (lockChat)=\"chatLocking($event)\">\r\n      </ngx-utilitario-chat-detail>\r\n    </div>\r\n  </div>\r\n</div>",
                        styles: [".ngx-utilitario-chat{display:flex;flex-flow:column;height:21.87rem}.ngx-utilitario-chat-list{display:flex;flex-flow:column;height:100%}.ngx-util-list-header{background:#fff;color:#324148;padding:1.37rem .93rem;border-bottom:.06rem solid #e0e3e4;text-align:center;font-size:1.12rem;font-weight:600;font-family:Lato,sans-serif;height:4.37rem}.ngx-util-list-header span{float:right;font-size:inherit}.ngx-util-list-detail{flex-grow:1;overflow:hidden}::ng-deep .scrollable-content{padding:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        ChatComponent.ctorParameters = function () { return []; };
        ChatComponent.propDecorators = {
            list: [{ type: core.Input }],
            chatDetail: [{ type: core.Input }],
            messageNew: [{ type: core.Output }],
            listClick: [{ type: core.Output }],
            chatDelete: [{ type: core.Output }],
            chatLock: [{ type: core.Output }]
        };
        return ChatComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que buscara palabras o chats
     */
    var ChatSearchComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatSearchComponent(formBuilder) {
            this.formBuilder = formBuilder;
            /**
             * Emitimos el valor de la busqueda
             */
            this.searchChange = new core.EventEmitter();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        ChatSearchComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
            this.createForm();
        };
        /**
         * Creamos el form
         */
        /**
         * Creamos el form
         * @return {?}
         */
        ChatSearchComponent.prototype.createForm = /**
         * Creamos el form
         * @return {?}
         */
        function () {
            this.searchForm = this.formBuilder.group({
                search: ''
            });
        };
        /**
         * Emitimos cambio
         */
        /**
         * Emitimos cambio
         * @return {?}
         */
        ChatSearchComponent.prototype.changeValue = /**
         * Emitimos cambio
         * @return {?}
         */
        function () {
            this.searchChange.emit(this.searchForm.controls.search.value);
        };
        ChatSearchComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-search',
                        template: "<div class=\"content ngx-util-search\">\n  <ngx-utilitario-input class=\"w-100 ngx-util-search-input\" label=\"busqueda\" iconMatSuffix=\"fa fa-search\"\n    [parent]=\"searchForm\" name=\"search\" (value)=\"changeValue()\"></ngx-utilitario-input>\n</div>",
                        styles: [".ngx-util-search{padding:1rem;background:#ececec;box-sizing:border-box}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline{background-color:#ececec;border-radius:3rem!important}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline-start{border-radius:3rem 0 0 3rem!important;padding-left:30px}::ng-deep .mat-form-field-label-wrapper{top:-1.2em}::ng-deep .mat-form-field-appearance-outline.mat-form-field-can-float.mat-form-field-should-float .mat-form-field-label{-webkit-transform:translate(1.5em,-1.3em) scale(.7)!important;transform:translate(1.5em,-1.3em) scale(.7)!important;width:133.33333%}::ng-deep .mat-form-field-appearance-outline .mat-form-field-outline-end{border-radius:0 3rem 3rem 0!important}::ng-deep .mat-input-element{padding-left:.7rem!important}::ng-deep .mat-form-field-wrapper{padding-bottom:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        ChatSearchComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        ChatSearchComponent.propDecorators = {
            searchChange: [{ type: core.Output }]
        };
        return ChatSearchComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que muestra todas las conversaciones que tienes
     */
    var ChatListComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatListComponent() {
            /**
             * Lista de chats que tienes
             */
            this.list = [];
            /**
             * Si se desea resaltar un texto en la lista de un chat
             */
            this.search = '';
            /**
             * Si hace click en una conversacion retornara un evento
             */
            this.clickList = new core.EventEmitter();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        ChatListComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * retorna el chat que realiza click
         * @param detail las propiedades del chat
         */
        /**
         * retorna el chat que realiza click
         * @param {?} detail las propiedades del chat
         * @return {?}
         */
        ChatListComponent.prototype.click = /**
         * retorna el chat que realiza click
         * @param {?} detail las propiedades del chat
         * @return {?}
         */
        function (detail) {
            this.clickList.emit(detail);
        };
        ChatListComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-list',
                        template: "<ngx-utilitario-perfect-scroll>\r\n    <ngx-utilitario-chat-list-detail *ngFor=\"let item of list\" [listDetail]=\"item\" [search]=\"search\" (clickDetail)=\"click($event)\"></ngx-utilitario-chat-list-detail>\r\n</ngx-utilitario-perfect-scroll>"
                    }] }
        ];
        /** @nocollapse */
        ChatListComponent.ctorParameters = function () { return []; };
        ChatListComponent.propDecorators = {
            list: [{ type: core.Input }],
            search: [{ type: core.Input }],
            clickList: [{ type: core.Output }]
        };
        return ChatListComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var moment = _moment;
    /**
     * Clase que trabajara sobre el tipo de dato "date" con la libreria "moment"
     */
    var   /**
     * Clase que trabajara sobre el tipo de dato "date" con la libreria "moment"
     */
    Fecha = /** @class */ (function () {
        /**
         * Obtiene la fecha actual
         */
        function Fecha() {
            this.now = new Date();
        }
        /**
         * Comparar dos fechas
         * @example
         *  this.fecha.compareDates(new Date())
         *  this.fecha.compareDates(new Date(), '2019-10-13')
         * @param date1 fecha a comparar
         * @param date2 si no envia una fecha se tomara la fecha actual
         * @return retorna true si la fecha1 es mayor a la fecha2
         */
        /**
         * Comparar dos fechas
         * \@example
         *  this.fecha.compareDates(new Date())
         *  this.fecha.compareDates(new Date(), '2019-10-13')
         * @param {?} date1 fecha a comparar
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @return {?} retorna true si la fecha1 es mayor a la fecha2
         */
        Fecha.prototype.compareDates = /**
         * Comparar dos fechas
         * \@example
         *  this.fecha.compareDates(new Date())
         *  this.fecha.compareDates(new Date(), '2019-10-13')
         * @param {?} date1 fecha a comparar
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @return {?} retorna true si la fecha1 es mayor a la fecha2
         */
        function (date1, date2) {
            if (date1 === undefined || date1 === null) {
                return false;
            }
            /** @type {?} */
            var dat1 = moment(date1);
            if (date2 === undefined || date2 === null) {
                date2 = new Date();
            }
            /** @type {?} */
            var dat2 = moment(date2);
            if (dat1.startOf('day').isSame(dat2.startOf('day'))) {
                return true;
            }
            return false;
        };
        /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * @example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         * @param  date1 fecha a comparar si es undefined retornara undefined
         * @param  date2 si no envia una fecha se tomara la fecha actual
         * @return retorna los dias de diferencia o undefined si los datos son enviados incorrectamente
         */
        /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * \@example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         * @param {?} date1 fecha a comparar si es undefined retornara undefined
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @return {?} retorna los dias de diferencia o undefined si los datos son enviados incorrectamente
         */
        Fecha.prototype.differenceDays = /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * \@example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         * @param {?} date1 fecha a comparar si es undefined retornara undefined
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @return {?} retorna los dias de diferencia o undefined si los datos son enviados incorrectamente
         */
        function (date1, date2) {
            if (date1 !== undefined && date1 !== null && date2 !== null) {
                if (!isNaN(date1.getTime())) {
                    /** @type {?} */
                    var dat1 = moment(date1);
                    if (date2 === undefined) {
                        date2 = new Date();
                    }
                    if (!isNaN(date2.getTime())) {
                        /** @type {?} */
                        var dat2 = moment(date2);
                        return dat1.diff(dat2, 'days', false);
                    }
                }
            }
            return undefined;
        };
        /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * @example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13', 'DD/MM/YYYY')
         * @param  date1 fecha a comparar
         * @param  date2 si no envia una fecha se tomara la fecha actual
         * @param  format  en este formato se retornara la fecha  en formato de moment por defecto tiene el formato DD/MM/YYYY
         *
         * @returns si la diferencia es entre -1 o 1 retornara ayer hoy o mañana si no retornara la fecha en el formato indicado
         */
        /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * \@example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13', 'DD/MM/YYYY')
         * @param {?} date1 fecha a comparar
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @param {?=} format  en este formato se retornara la fecha  en formato de moment por defecto tiene el formato DD/MM/YYYY
         *
         * @return {?} si la diferencia es entre -1 o 1 retornara ayer hoy o mañana si no retornara la fecha en el formato indicado
         */
        Fecha.prototype.differenceDaysText = /**
         * Cuenta los dias entre dos fechas. si no se envia la fecha 2 se tomara la fecha actual
         * \@example
         *  this.fecha.DifferenceDays(new Date())
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13')
         *  this.fecha.DifferenceDays(new Date(), '2019-10-13', 'DD/MM/YYYY')
         * @param {?} date1 fecha a comparar
         * @param {?=} date2 si no envia una fecha se tomara la fecha actual
         * @param {?=} format  en este formato se retornara la fecha  en formato de moment por defecto tiene el formato DD/MM/YYYY
         *
         * @return {?} si la diferencia es entre -1 o 1 retornara ayer hoy o mañana si no retornara la fecha en el formato indicado
         */
        function (date1, date2, format) {
            if (date1 !== undefined && date1 !== null && date2 !== null) {
                if (!isNaN(date1.getTime())) {
                    /** @type {?} */
                    var dat1 = moment(date1);
                    /** @type {?} */
                    var dias = this.differenceDays(date1, date2);
                    if (format === undefined) {
                        format = 'DD/MM/YYYY';
                    }
                    switch (dias) {
                        case 0: {
                            return 'Hoy';
                        }
                        case 1: {
                            return 'Mañana';
                        }
                        case -1: {
                            return 'Ayer';
                        }
                        default: {
                            return dat1.format(format);
                        }
                    }
                }
            }
            return undefined;
        };
        /**
         * Cambia el formato de la fecha en formato de moment
         * @example
         *  this.fecha.DifferenceDays(new Date(), 'DD/MM/YYYY')
         *  YYYY    4-digits Year                                                   2018
         *  YY      2-digits Year                                                   18
         *  M       2-digits Month number, omits leading 0                          7
         *  MM      2-digits Month number                                           07
         *  MMM     3-letters Month name                                            Jul
         *  MMMM    Full Month name                                                 July
         *  dddd    Full day name                                                   Sunday
         *  gggg    4-digits Week year                                              2018
         *  gg      2-digits Week year                                              18
         *  w       Week of the year without leading zero                           18
         *  ww      Week of the year with leading zero                              18
         *  e       Day of the week, starts at 0                                    4
         *  D       2-digits day number, omits leading 0                            9
         *  DD      2-digits day number                                             09
         *  Do      Day number with ordinal                                         9th
         *  T       Indicates the start of the time part
         *  HH      2-digits hours (24 hour time) from 0 to 23                      22
         *  H       2-digits hours (24 hour time) from 0 to 23 without leading 0    22
         *  kk      2-digits hours (24 hour time) from 1 to 24                      23
         *  k       2-digits hours (24 hour time) from 1 to 24 without leading 0    23
         *  a/A     am or pm	                                                    pm
         *  hh      2-digits hours (12 hour time)                                   11
         *  mm      2-digits minutes	                                            22
         *  ss      2-digits seconds	                                            40
         *  s       2-digits seconds without leading zero                           40
         *  S       1-digits milliseconds                                           1
         *  SS      2-digits milliseconds                                           12
         *  SSS     3-digits milliseconds                                           123
         *  Z       The timezone                                                    +02:00
         *  x       UNIX timestamp in milliseconds                                  1410432140575
         *
         * @param date fecha a cambiar el formato
         * @param format formato que se desea la fecha
         *
         * @returns la fecha en el formato deseado
         */
        /**
         * Cambia el formato de la fecha en formato de moment
         * \@example
         *  this.fecha.DifferenceDays(new Date(), 'DD/MM/YYYY')
         *  YYYY    4-digits Year                                                   2018
         *  YY      2-digits Year                                                   18
         *  M       2-digits Month number, omits leading 0                          7
         *  MM      2-digits Month number                                           07
         *  MMM     3-letters Month name                                            Jul
         *  MMMM    Full Month name                                                 July
         *  dddd    Full day name                                                   Sunday
         *  gggg    4-digits Week year                                              2018
         *  gg      2-digits Week year                                              18
         *  w       Week of the year without leading zero                           18
         *  ww      Week of the year with leading zero                              18
         *  e       Day of the week, starts at 0                                    4
         *  D       2-digits day number, omits leading 0                            9
         *  DD      2-digits day number                                             09
         *  Do      Day number with ordinal                                         9th
         *  T       Indicates the start of the time part
         *  HH      2-digits hours (24 hour time) from 0 to 23                      22
         *  H       2-digits hours (24 hour time) from 0 to 23 without leading 0    22
         *  kk      2-digits hours (24 hour time) from 1 to 24                      23
         *  k       2-digits hours (24 hour time) from 1 to 24 without leading 0    23
         *  a/A     am or pm	                                                    pm
         *  hh      2-digits hours (12 hour time)                                   11
         *  mm      2-digits minutes	                                            22
         *  ss      2-digits seconds	                                            40
         *  s       2-digits seconds without leading zero                           40
         *  S       1-digits milliseconds                                           1
         *  SS      2-digits milliseconds                                           12
         *  SSS     3-digits milliseconds                                           123
         *  Z       The timezone                                                    +02:00
         *  x       UNIX timestamp in milliseconds                                  1410432140575
         *
         * @param {?} date fecha a cambiar el formato
         * @param {?} format formato que se desea la fecha
         *
         * @return {?} la fecha en el formato deseado
         */
        Fecha.prototype.format = /**
         * Cambia el formato de la fecha en formato de moment
         * \@example
         *  this.fecha.DifferenceDays(new Date(), 'DD/MM/YYYY')
         *  YYYY    4-digits Year                                                   2018
         *  YY      2-digits Year                                                   18
         *  M       2-digits Month number, omits leading 0                          7
         *  MM      2-digits Month number                                           07
         *  MMM     3-letters Month name                                            Jul
         *  MMMM    Full Month name                                                 July
         *  dddd    Full day name                                                   Sunday
         *  gggg    4-digits Week year                                              2018
         *  gg      2-digits Week year                                              18
         *  w       Week of the year without leading zero                           18
         *  ww      Week of the year with leading zero                              18
         *  e       Day of the week, starts at 0                                    4
         *  D       2-digits day number, omits leading 0                            9
         *  DD      2-digits day number                                             09
         *  Do      Day number with ordinal                                         9th
         *  T       Indicates the start of the time part
         *  HH      2-digits hours (24 hour time) from 0 to 23                      22
         *  H       2-digits hours (24 hour time) from 0 to 23 without leading 0    22
         *  kk      2-digits hours (24 hour time) from 1 to 24                      23
         *  k       2-digits hours (24 hour time) from 1 to 24 without leading 0    23
         *  a/A     am or pm	                                                    pm
         *  hh      2-digits hours (12 hour time)                                   11
         *  mm      2-digits minutes	                                            22
         *  ss      2-digits seconds	                                            40
         *  s       2-digits seconds without leading zero                           40
         *  S       1-digits milliseconds                                           1
         *  SS      2-digits milliseconds                                           12
         *  SSS     3-digits milliseconds                                           123
         *  Z       The timezone                                                    +02:00
         *  x       UNIX timestamp in milliseconds                                  1410432140575
         *
         * @param {?} date fecha a cambiar el formato
         * @param {?} format formato que se desea la fecha
         *
         * @return {?} la fecha en el formato deseado
         */
        function (date, format) {
            if (date !== undefined && date !== null) {
                if (!isNaN(date.getTime())) {
                    /** @type {?} */
                    var dat1 = moment(date);
                    return dat1.format(format);
                }
            }
            return undefined;
        };
        return Fecha;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Variables para utilizar en la libreria
     * @type {?}
     */
    var environment = {
        production: false,
        // tslint:disable-next-line: max-line-length
        imgUsuario: 'https://firebasestorage.googleapis.com/v0/b/ngx-utilitario-rclt.appspot.com/o/default-user.jpg?alt=media&token=bac4339b-4cfa-4751-9fcf-8090950c7d84',
        // tslint:disable-next-line: max-line-length
        chatWifi: 'https://firebasestorage.googleapis.com/v0/b/ngx-utilitario-rclt.appspot.com/o/wifi.png?alt=media&token=a90ade22-6aa5-4200-9aa4-b5438c2713ab'
    };

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que muestra la lista de conversaciones
     */
    var ChatListDetailComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatListDetailComponent() {
            /**
             * Caracteristicas de una conversacion
             */
            this.listDetail = undefined;
            /**
             * El mensaje a mostrar cuando se envie una imagen
             */
            this.imageName = 'Foto';
            /**
             * Si se desea resaltar un texto en el chat
             */
            this.search = '';
            /**
             * Retorna un evento cuando cuando cuando hace click en una conversacion
             */
            this.clickDetail = new core.EventEmitter();
            this.date = new Fecha();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        ChatListDetailComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Si realiza un click en una conversacion
         */
        /**
         * Si realiza un click en una conversacion
         * @return {?}
         */
        ChatListDetailComponent.prototype.click = /**
         * Si realiza un click en una conversacion
         * @return {?}
         */
        function () {
            this.clickDetail.emit(this.listDetail);
        };
        /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param messages recibe todos los mensajes de la conversacion
         */
        /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param {?} messages recibe todos los mensajes de la conversacion
         * @return {?}
         */
        ChatListDetailComponent.prototype.messageLast = /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param {?} messages recibe todos los mensajes de la conversacion
         * @return {?}
         */
        function (messages) {
            if (messages !== undefined && messages !== null) {
                if (messages.length > 0) {
                    if (messages[messages.length - 1].img === null ||
                        messages[messages.length - 1].img === undefined ||
                        messages[messages.length - 1].img === '') {
                        return messages[messages.length - 1].message;
                    }
                    else {
                        return this.imageName;
                    }
                }
            }
            return '';
        };
        /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param messages recibe todos los mensajes de la conversacion
         */
        /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param {?} messages recibe todos los mensajes de la conversacion
         * @return {?}
         */
        ChatListDetailComponent.prototype.dateLast = /**
         * De la lista de mensajes obtememos el ultimo mensaje y lo mostramos en caso de imagen mostramos la palabra foto
         * debe estar ordenado los mensajes
         * @param {?} messages recibe todos los mensajes de la conversacion
         * @return {?}
         */
        function (messages) {
            if (messages !== undefined && messages !== null) {
                if (messages.length > 0) {
                    if (!isNaN(new Date(messages[messages.length - 1].date).getTime())) {
                        if (this.date.differenceDays(new Date(messages[messages.length - 1].date))) {
                            /** @type {?} */
                            var date = new Date(messages[messages.length - 1].date);
                            return this.date.format(date, 'DD/MM/YYYY');
                        }
                        else {
                            return messages[messages.length - 1].hour;
                        }
                    }
                }
            }
            return '';
        };
        /**
         * Funcion para verficar el estado actual del usuario con el que se esta conversando
         * @param listDetail propiedades de la conversacion conectado, desconectado
         */
        /**
         * Funcion para verficar el estado actual del usuario con el que se esta conversando
         * @param {?} listDetail propiedades de la conversacion conectado, desconectado
         * @return {?}
         */
        ChatListDetailComponent.prototype.chatState = /**
         * Funcion para verficar el estado actual del usuario con el que se esta conversando
         * @param {?} listDetail propiedades de la conversacion conectado, desconectado
         * @return {?}
         */
        function (listDetail) {
            if (listDetail !== undefined) {
                return listDetail.state;
            }
            else {
                return false;
            }
        };
        /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param image url o ubicacion de la imagen
         * @returns la imagen o una por va
         */
        /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param {?} listDetail
         * @return {?} la imagen o una por va
         */
        ChatListDetailComponent.prototype.imageValidate = /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param {?} listDetail
         * @return {?} la imagen o una por va
         */
        function (listDetail) {
            if (listDetail !== null && listDetail !== undefined) {
                if (listDetail.img !== '' && listDetail.img !== undefined && listDetail.img !== null) {
                    return listDetail.img;
                }
            }
            return environment.imgUsuario;
        };
        /**
         * Validamos si mostramos una validacion o no
         */
        /**
         * Validamos si mostramos una validacion o no
         * @param {?} notification
         * @return {?}
         */
        ChatListDetailComponent.prototype.notificationValidate = /**
         * Validamos si mostramos una validacion o no
         * @param {?} notification
         * @return {?}
         */
        function (notification) {
            if (notification !== undefined && notification !== null) {
                if (notification > 0) {
                    return true;
                }
            }
            return false;
        };
        /**
         * Obtener nombre
         */
        /**
         * Obtener nombre
         * @param {?} listDetail
         * @return {?}
         */
        ChatListDetailComponent.prototype.validateListDetail = /**
         * Obtener nombre
         * @param {?} listDetail
         * @return {?}
         */
        function (listDetail) {
            if (listDetail !== undefined && listDetail !== null) {
                return true;
            }
            return false;
        };
        ChatListDetailComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-list-detail',
                        template: "<div id=\"div_detailMessages\" class=\"content ngx-util-chat-detail\" (click)=\"click()\"\r\n  *ngIf=\"validateListDetail(listDetail)\">\r\n  <!--Imagen-->\r\n  <div class=\"list-detail-img\">\r\n    <img class=\"img-fluid rounded-circle\" title=\"listDetail.name\" alt=\"User Image\" src={{imageValidate(listDetail)}} />\r\n    <div *ngIf=\"chatState(listDetail)\" class=\"list-detail-img-state\"></div>\r\n  </div>\r\n  <!--Nombre y mensaje-->\r\n  <div class=\"list-detail-name\">\r\n    <div class=\"name\" innerHTML=\"{{ listDetail.name | highlight : search}}\"></div>\r\n    <div class=\"message\"  innerHTML=\"{{ messageLast(listDetail.message) | highlight : search}}\"></div>\r\n  </div>\r\n  <!--fecha y notifiaciones-->\r\n  <div class=\"list-detail-date\">\r\n    <div class=\"date\">\r\n      {{dateLast(listDetail.message)}}\r\n    </div>\r\n    <div *ngIf=\"notificationValidate(listDetail.notification)\" class=\"badge badge-success badge-pill notification\">\r\n      {{listDetail.notification}}\r\n    </div>\r\n  </div>\r\n</div>\r\n",
                        styles: [".ngx-util-chat-detail{display:flex;width:98%;margin-left:.3rem;border-bottom:1px solid #e0e3e4;padding:.5rem .8rem;cursor:pointer}.ngx-utili-date-not-chat{padding:0}.ngx-util-date-chat{font-size:.7rem}.list-detail-img-state{background:#22af47;border:.06rem solid #fff;width:.62rem;height:.62rem;position:absolute;border-radius:50%;right:.12rem;bottom:.12rem}.list-detail-img{position:relative;width:2.8rem;min-width:2rem;margin-right:.5rem}.list-detail-name{flex:1 1 auto}.list-detail-name .name{font-size:.875rem;font-weight:700;color:#324148}.list-detail-name .message{font-size:.815rem;color:#b0b0b0;text-overflow:ellipsis}.list-detail-date{flex:0 0 auto}.list-detail-date .date{font-size:.815rem;color:#5e7d8a}.list-detail-date .notification{background-color:#e7b723;padding:.25rem .5rem;float:right}"]
                    }] }
        ];
        /** @nocollapse */
        ChatListDetailComponent.ctorParameters = function () { return []; };
        ChatListDetailComponent.propDecorators = {
            listDetail: [{ type: core.Input }],
            imageName: [{ type: core.Input }],
            search: [{ type: core.Input }],
            clickDetail: [{ type: core.Output }]
        };
        return ChatListDetailComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EMessageType = {
        /**
         * si yo he enviado el mensaje
         */
        sent: 1,
        /**
         * si yo he recibido el mensaje
         */
        recived: 0,
    };
    EMessageType[EMessageType.sent] = 'sent';
    EMessageType[EMessageType.recived] = 'recived';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EMessageState = {
        /**
         * Mensaje enviado
         */
        sent: 0,
        /**
         * Mensaje recibido
         */
        received: 1,
        /**
         * Mensaje leido
         */
        read: 2,
    };
    EMessageState[EMessageState.sent] = 'sent';
    EMessageState[EMessageState.received] = 'received';
    EMessageState[EMessageState.read] = 'read';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EChatLock = {
        /**
         * Si el chat esta desbloqueado
         */
        unlocked: 0,
        /**
         * Si yo eh bloqueado el chat
         */
        lock: 1,
        /**
         * Si he sido bloqueado
         */
        locked: 2,
    };
    EChatLock[EChatLock.unlocked] = 'unlocked';
    EChatLock[EChatLock.lock] = 'lock';
    EChatLock[EChatLock.locked] = 'locked';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EScrollPosition = {
        /**
         * Si se dedea ir al inicio
         */
        start: 0,
        /**
         * Si se desea ir al final
         */
        end: -1,
    };
    EScrollPosition[EScrollPosition.start] = 'start';
    EScrollPosition[EScrollPosition.end] = 'end';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente donde mostramos los mensajes de la conversacion
     */
    var ChatDetailComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatDetailComponent() {
            /**
             * Las caracteristicas de la conversacion
             * Si se envia null en lock no podra bloquear ni desbloquear un chat
             */
            this.chatDetail = undefined;
            // TODO Eliminar al probarlo
            // @Input() chatDetail: IChatDetail = {
            //   id: '',
            //   img: '',
            //   name: 'renato',
            //   state: null,
            //   messages: [],
            //   lock: EChatLock.unlocked
            // };
            /**
             * Alt en icono de trash
             */
            this.messageTrashIcon = 'eliminar conversacion';
            /**
             * Alt en icono de trash
             */
            this.messageLockIcon = 'bloquear conversacion';
            /**
             * Alt en icono de trash
             */
            this.messageUnlockIcon = 'desbloquear conversacion';
            /**
             * Imagen a mostrar en el chat cuando chatDetail esta vacio
             */
            this.imageChat = environment.chatWifi;
            /**
             * Al enviar un nuevo mensaje
             */
            this.newMessage = new core.EventEmitter();
            /**
             * Al eliminar la conversacion
             */
            this.deleteMessages = new core.EventEmitter();
            /**
             * Al bloquear una conversacion
             */
            this.lockChat = new core.EventEmitter();
            /**
             * Variable para usar un enum en html
             */
            this.EChatLock = EChatLock;
            /**
             * posicion del scroll
             */
            this.position = [EScrollPosition.start, EScrollPosition.end];
        }
        /**
         * Se validara si el cambio es de movetomessage
         * Validara si se cambio de chat y eliminar previsualizacion
         * @param changes index del mensaje a mostrar
         */
        /**
         * Se validara si el cambio es de movetomessage
         * Validara si se cambio de chat y eliminar previsualizacion
         * @param {?} changes index del mensaje a mostrar
         * @return {?}
         */
        ChatDetailComponent.prototype.ngOnChanges = /**
         * Se validara si el cambio es de movetomessage
         * Validara si se cambio de chat y eliminar previsualizacion
         * @param {?} changes index del mensaje a mostrar
         * @return {?}
         */
        function (changes) {
            if (changes.moveToMessage) {
                this.messageMove(changes.moveToMessage.currentValue);
            }
            if (changes.chatDetail) {
                this.filesPreview = undefined;
            }
        };
        /**
         * Emitimos un nuevo mensaje y añadimos el mensaje
         * si no tiene mensajes ni imagenes no realizara ningua accion
         * @param message mensaje enviado
         */
        /**
         * Emitimos un nuevo mensaje y añadimos el mensaje
         * si no tiene mensajes ni imagenes no realizara ningua accion
         * @param {?} message mensaje enviado
         * @return {?}
         */
        ChatDetailComponent.prototype.messageSend = /**
         * Emitimos un nuevo mensaje y añadimos el mensaje
         * si no tiene mensajes ni imagenes no realizara ningua accion
         * @param {?} message mensaje enviado
         * @return {?}
         */
        function (message) {
            var _this = this;
            console.log('prueba', this.filesPreview, message);
            if ((message === '' || message === null) && this.filesPreview === undefined) {
                return;
            }
            /** @type {?} */
            var newMessage;
            if (this.filesPreview === undefined) {
                newMessage = {
                    messageState: EMessageState.sent,
                    date: new Fecha().format(new Date(), 'LL'),
                    hour: new Fecha().format(new Date(), 'HH:mm'),
                    img: undefined,
                    message: message,
                    messageType: EMessageType.sent
                };
                this.newMessage.emit(newMessage);
            }
            else {
                Array.from(this.filesPreview).forEach((/**
                 * @param {?} file
                 * @return {?}
                 */
                function (file) {
                    newMessage = {
                        messageState: EMessageState.sent,
                        date: new Fecha().format(new Date(), 'LL'),
                        hour: new Fecha().format(new Date(), 'HH:mm'),
                        img: file,
                        message: message,
                        messageType: EMessageType.sent
                    };
                    _this.newMessage.emit(newMessage);
                }));
                this.filesPreview = undefined;
            }
        };
        /**
         * imagePreview
         * @param fileList imagenes Seleccionadas
         */
        /**
         * imagePreview
         * @param {?} fileList imagenes Seleccionadas
         * @return {?}
         */
        ChatDetailComponent.prototype.imagePreview = /**
         * imagePreview
         * @param {?} fileList imagenes Seleccionadas
         * @return {?}
         */
        function (fileList) {
            this.filesPreview = fileList;
        };
        /**
         * Se eliminaran los mensajes en esta conversacion
         */
        /**
         * Se eliminaran los mensajes en esta conversacion
         * @return {?}
         */
        ChatDetailComponent.prototype.chatDelete = /**
         * Se eliminaran los mensajes en esta conversacion
         * @return {?}
         */
        function () {
            this.deleteMessages.emit();
        };
        /**
         * Se bloqueara la conversacion
         */
        /**
         * Se bloqueara la conversacion
         * @return {?}
         */
        ChatDetailComponent.prototype.lock = /**
         * Se bloqueara la conversacion
         * @return {?}
         */
        function () {
            this.chatDetail.lock = EChatLock.lock;
            this.lockChat.emit(EChatLock.lock);
        };
        /**
         * Se desbloqueara la conversacion
         */
        /**
         * Se desbloqueara la conversacion
         * @return {?}
         */
        ChatDetailComponent.prototype.unlock = /**
         * Se desbloqueara la conversacion
         * @return {?}
         */
        function () {
            this.chatDetail.lock = EChatLock.unlocked;
            this.lockChat.emit(EChatLock.unlocked);
        };
        /**
         * Valida si el estado es el esperado
         * @param state bloqueo, bloqueado o desbloqueado
         */
        /**
         * Valida si el estado es el esperado
         * @param {?} state bloqueo, bloqueado o desbloqueado
         * @param {?} expetedState
         * @return {?}
         */
        ChatDetailComponent.prototype.lookStateValidate = /**
         * Valida si el estado es el esperado
         * @param {?} state bloqueo, bloqueado o desbloqueado
         * @param {?} expetedState
         * @return {?}
         */
        function (state, expetedState) {
            if (state === expetedState) {
                return true;
            }
            return false;
        };
        /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param image url o ubicacion de la imagen
         * @returns la imagen o una por va
         */
        /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param {?} image url o ubicacion de la imagen
         * @return {?} la imagen o una por va
         */
        ChatDetailComponent.prototype.imageValidate = /**
         * Si la imagen es null, undefined o vacia utilizar una por defecto
         * @param {?} image url o ubicacion de la imagen
         * @return {?} la imagen o una por va
         */
        function (image) {
            if (image === null || image === undefined || image === '') {
                return environment.imgUsuario;
            }
            else {
                return image;
            }
        };
        /**
         * Validaremos la variable chat detail
         */
        /**
         * Validaremos la variable chat detail
         * @return {?}
         */
        ChatDetailComponent.prototype.validateChatDetail = /**
         * Validaremos la variable chat detail
         * @return {?}
         */
        function () {
            if (this.chatDetail === undefined || this.chatDetail === null) {
                return false;
            }
            return true;
        };
        /**
         * Cambiar el estado de 1 o 0 a letras
         * @param state Enum del estado actual
         */
        /**
         * Cambiar el estado de 1 o 0 a letras
         * @param {?} state Enum del estado actual
         * @return {?}
         */
        ChatDetailComponent.prototype.nameState = /**
         * Cambiar el estado de 1 o 0 a letras
         * @param {?} state Enum del estado actual
         * @return {?}
         */
        function (state) {
            if (state === 1) {
                return 'Online';
            }
            return 'Offline';
        };
        /**
         * Vamos a mover al mensaje indicado
         * @param id id del mensaje a moverse
         */
        /**
         * Vamos a mover al mensaje indicado
         * @param {?} id id del mensaje a moverse
         * @return {?}
         */
        ChatDetailComponent.prototype.messageMove = /**
         * Vamos a mover al mensaje indicado
         * @param {?} id id del mensaje a moverse
         * @return {?}
         */
        function (id) {
            if (id !== undefined) {
                this.elementName = 'message_' + id;
            }
            else {
                this.elementName = undefined;
            }
        };
        /**
         * Cerrar la ventanta preview
         */
        /**
         * Cerrar la ventanta preview
         * @return {?}
         */
        ChatDetailComponent.prototype.closePreview = /**
         * Cerrar la ventanta preview
         * @return {?}
         */
        function () {
            this.filesPreview = undefined;
        };
        ChatDetailComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-detail',
                        template: "<!--Si es invalido chatdetail mostraremos una imagen-->\r\n<div class=\"container-fluid ngx-util-detail no-margin no-padding\" *ngIf=\"!validateChatDetail()\"\r\n  style=\"background: #ffe4c4\">\r\n  <img class=\"ngx-util-img-height-res-center\" title=\"Chat\" alt=\"Chat Image\" src={{imageChat}} />\r\n</div>\r\n<!--Si es valido chatdetail mostraremos el chat-->\r\n<div class=\"container-fluid ngx-util-detail no-margin no-padding\" *ngIf=\"validateChatDetail()\">\r\n  <!--Cabecera del chat-->\r\n  <div class=\"row ngx-util-detail-head no-margin\">\r\n    <div class=\"img-fluid detail-head-img\">\r\n      <img class=\"img-fluid rounded-circle img-profile-chat-detail\" alt=\"chatDetail.name\"\r\n        src=\"{{imageValidate(chatDetail.img)}}\" />\r\n    </div>\r\n    <div class=\"detail-head-name\">\r\n      <div class=\"row\">\r\n        <div class=\"col-12\">\r\n          {{chatDetail.name}}\r\n        </div>\r\n      </div>\r\n      <div class=\"row\">\r\n        <div class=\"col-12 detail-head-state-letters\">{{nameState(chatDetail.state)}}</div>\r\n      </div>\r\n    </div>\r\n    <div class=\"detail-head-actions no-padding\">\r\n      <div class=\"ngx-util-btns-actions\">\r\n        <button id=\"btn_chatDelete\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\"\r\n          (click)=\"chatDelete()\" title=\"{{messageTrashIcon}}\">\r\n          <i class=\"fa fa-trash-o\" style=\"color: #808080\" aria-hidden=\"true\" title=\"{{messageTrashIcon}}\"></i>\r\n        </button>\r\n        <button id=\"btn_chatLock\" *ngIf=\"lookStateValidate(chatDetail.lock, EChatLock.unlocked)\" type=\"button\"\r\n          class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" (click)=\"lock()\" title=\"{{messageLockIcon}}\">\r\n          <i class=\"fa fa-ban\" style=\"color: #c2272d\" aria-hidden=\"true\" title=\"{{messageLockIcon}}\"></i>\r\n        </button>\r\n        <button id=\"btn_chatUnlock\" *ngIf=\"lookStateValidate(chatDetail.lock, EChatLock.lock)\" type=\"button\"\r\n          class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" title=\"{{messageUnlockIcon}}\" (click)=\"unlock()\">\r\n          <i class=\"fa fa-unlock\" style=\"color: #228B22\" aria-hidden=\"true\" title=\"{{messageUnlockIcon}}\"></i>\r\n        </button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n  <!--Mensajes del chat-->\r\n  <div class=\"ngx-util-detail-messages\" style=\"background: rgb(245, 245, 246);\" *ngIf=\"filesPreview === undefined\">\r\n    <ngx-utilitario-perfect-scroll [position]=\"position\" [elementName] = \"elementName\" >\r\n      <ngx-utilitario-chat-detail-message [messages]=\"chatDetail.messages\"></ngx-utilitario-chat-detail-message>\r\n    </ngx-utilitario-perfect-scroll>\r\n  </div>\r\n  <div *ngIf=\"filesPreview !== undefined\">\r\n    <ngx-utilitario-chat-detail-preview [files]=\"filesPreview\" (close)=\"closePreview()\"></ngx-utilitario-chat-detail-preview>\r\n  </div>\r\n  <!--Agregar chat-->\r\n  <div class=\"container-fluid ngx-util-detail-add\">\r\n    <div class=\"row\">\r\n      <ngx-utilitario-chat-detail-add class=\"col-12 ngx-utilitario-chat-agregar\" (newMessage)=\"messageSend($event)\" (newImage)=\"imagePreview($event)\"\r\n        [disabled]=\"chatDetail.lock\"></ngx-utilitario-chat-detail-add>\r\n    </div>\r\n  </div>\r\n</div>",
                        styles: [".ngx-util-detail{display:flex;flex-flow:column;width:100%;height:100%;border:.0625rem solid #e0e3e4;overflow:hidden}.ngx-util-detail-head{padding:.62rem .93rem;height:4.37rem;border-bottom:.0625rem solid #e0e3e4}.detail-head-img{position:relative;width:4.8rem;min-width:2rem;margin-right:.5rem}.img-profile-chat-detail{height:3.125rem}.detail-head-name{font-size:1rem;font-weight:700;flex:1 1 auto;color:#324148}.detail-head-state-letters{font-size:.75rem;width:3rem;color:#b0b0b0}.detail-head-actions{flex:0 0 auto}.ngx-util-detail-messages{flex-grow:1;overflow:hidden;height:-webkit-fill-available;overflow-y:hidden}.ngx-util-detail-messages-show{height:100%;background:#000}.ngx-util-detail-add{height:4.37rem}"]
                    }] }
        ];
        /** @nocollapse */
        ChatDetailComponent.ctorParameters = function () { return []; };
        ChatDetailComponent.propDecorators = {
            chatDetail: [{ type: core.Input }],
            messageTrashIcon: [{ type: core.Input }],
            messageLockIcon: [{ type: core.Input }],
            messageUnlockIcon: [{ type: core.Input }],
            imageChat: [{ type: core.Input }],
            moveToMessage: [{ type: core.Input }],
            newMessage: [{ type: core.Output }],
            deleteMessages: [{ type: core.Output }],
            lockChat: [{ type: core.Output }]
        };
        return ChatDetailComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que permite agregar un mensaje y una nueva imagen
     */
    var ChatDetailAddComponent = /** @class */ (function () {
        /**
         * @ignore
         * @param formBuilder inicializacion de formulario
         */
        function ChatDetailAddComponent(formBuilder) {
            this.formBuilder = formBuilder;
            /**
             * Validamos si puede escribir o no un mensaje
             * \@example
             * 0 si puede enviar un mensaje
             * 1 no puede enviar mensaje
             * 2 no puede enviar mensaje
             */
            this.disabled = 0;
            /**
             * Mensaje que aparecera en la caja de texto
             */
            this.placeholder = 'Escribir mensaje ...';
            /**
             * Al enviar un mensaje emite un evento
             */
            this.newMessage = new core.EventEmitter();
            /**
             * Al enviar una imagen emite un evento con todos los archivos cargados
             */
            this.newImage = new core.EventEmitter();
        }
        /**
         * Inicializamos el formulario
         */
        /**
         * Inicializamos el formulario
         * @return {?}
         */
        ChatDetailAddComponent.prototype.ngOnInit = /**
         * Inicializamos el formulario
         * @return {?}
         */
        function () {
            this.createForm();
        };
        /**
         * añadimos el control mensaje e imagen al formulario
         */
        /**
         * añadimos el control mensaje e imagen al formulario
         * @return {?}
         */
        ChatDetailAddComponent.prototype.createForm = /**
         * añadimos el control mensaje e imagen al formulario
         * @return {?}
         */
        function () {
            this.messageForm = this.formBuilder.group({
                message: '',
            });
        };
        /**
         * Emitimos de que hay un nuevo mensaje y limpiamos la caja de texto
         */
        /**
         * Emitimos de que hay un nuevo mensaje y limpiamos la caja de texto
         * @return {?}
         */
        ChatDetailAddComponent.prototype.sendMessage = /**
         * Emitimos de que hay un nuevo mensaje y limpiamos la caja de texto
         * @return {?}
         */
        function () {
            this.newMessage.emit(this.messageForm.controls.message.value);
            this.messageForm.reset();
        };
        /**
         * Emitimos de que hay una nueva imagen a enviar
         */
        /**
         * Emitimos de que hay una nueva imagen a enviar
         * @param {?} event
         * @return {?}
         */
        ChatDetailAddComponent.prototype.sendImage = /**
         * Emitimos de que hay una nueva imagen a enviar
         * @param {?} event
         * @return {?}
         */
        function (event) {
            /** @type {?} */
            var target = (/** @type {?} */ (event.target));
            /** @type {?} */
            var fileList = target.files;
            if (fileList && fileList.length > 0) {
                this.newImage.emit(fileList);
            }
        };
        ChatDetailAddComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-detail-add',
                        template: "<div class=\"container-fluid\">\r\n  <div class=\"row ngx-util-detail-add no-margin\">\r\n    <!--Input-->\r\n    <div class=\"col-11\">\r\n      <form [formGroup]=\"messageForm\">\r\n        <input id=\"txt_message\" class=\"col-12\" formControlName=\"message\" [attr.disabled]=\"disabled ? '' : null\"\r\n        [placeholder]=\"placeholder\" (keyup.enter)=\"sendMessage()\">\r\n      </form>\r\n    </div>\r\n    <!--Acciones-->\r\n    <div class=\"col-1 no-padding\">\r\n      <div class=\"ngx-util-btns-actions\">\r\n        <input class=\"ngx-util-input-file\" type=\"file\" accept=\"image/*\" #file (change)=\"sendImage($event)\" multiple>\r\n        <button id=\"btn_sendImage\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" (click)=\"file.click()\" [attr.disabled]=\"disabled ? '' : null\"><i\r\n            class=\"fa fa-camera\" aria-hidden=\"true\"></i></button>\r\n        <button id=\"btn_sendMessage\" type=\"button\" class=\"col-6 btn ngx-util-btn-icon ngx-util-btn-gray\" [attr.disabled]=\"disabled ? '' : null\"\r\n          (click)=\"sendMessage()\"><i class=\"fa fa-paper-plane\" aria-hidden=\"true\"></i></button>\r\n      </div>\r\n    </div>\r\n  </div>\r\n</div>",
                        styles: [".no-padding{padding-left:0!important;padding-right:0!important}.ngx-util-detail-add{padding:.95rem;background:#fff;display:flex}.ngx-util-detail-add input{background:#f5f5f6;border-radius:4.5rem;box-shadow:none;display:inline-block;padding:.9rem!important;font-size:.8rem;border:none;flex:1 1 auto}.ngx-util-btns-actions{flex:0 0 auto;width:3rem}"]
                    }] }
        ];
        /** @nocollapse */
        ChatDetailAddComponent.ctorParameters = function () { return [
            { type: forms.FormBuilder }
        ]; };
        ChatDetailAddComponent.propDecorators = {
            disabled: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            newMessage: [{ type: core.Output }],
            newImage: [{ type: core.Output }]
        };
        return ChatDetailAddComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que muestra los mensajes de un chat
     */
    var ChatDetailMessageComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatDetailMessageComponent() {
            /**
             * Variable para usar enum en html
             */
            this.EMessageState = EMessageState;
            this.date = new Fecha();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Si el index es 0 a la fecha enviada se le restara un dia para que retorne true y genere una linea
         * Si el index es mayor a 0 tomara la fecha del mensaje anterior y la comparara
         * si se envia un undefined un null o una fecha invalidad no imprimira linea
         * @param date recibe la fecha del mensaje
         * @param index index del elemento en el arreglo
         * @returns si debe mostrar una linea o no
         */
        /**
         * Si el index es 0 a la fecha enviada se le restara un dia para que retorne true y genere una linea
         * Si el index es mayor a 0 tomara la fecha del mensaje anterior y la comparara
         * si se envia un undefined un null o una fecha invalidad no imprimira linea
         * @param {?} dateString
         * @param {?} index index del elemento en el arreglo
         * @return {?} si debe mostrar una linea o no
         */
        ChatDetailMessageComponent.prototype.dayLine = /**
         * Si el index es 0 a la fecha enviada se le restara un dia para que retorne true y genere una linea
         * Si el index es mayor a 0 tomara la fecha del mensaje anterior y la comparara
         * si se envia un undefined un null o una fecha invalidad no imprimira linea
         * @param {?} dateString
         * @param {?} index index del elemento en el arreglo
         * @return {?} si debe mostrar una linea o no
         */
        function (dateString, index) {
            /** @type {?} */
            var date;
            if (dateString !== null && dateString !== undefined && dateString !== '') {
                date = new Date(dateString);
                if (!isNaN(date.getTime())) {
                    /** @type {?} */
                    var tDate = void 0;
                    if (index === 0) {
                        tDate = new Date(date);
                        tDate.setDate(tDate.getDate() - 1);
                    }
                    else {
                        tDate = new Date(this.messages[index - 1].date);
                    }
                    return !this.date.compareDates(new Date(date), tDate);
                }
            }
            return false;
        };
        /**
         * Compara los dias entre la fecha actual y la enviada para insertar el texto en el chat
         * @param date fecha del mensaje
         */
        /**
         * Compara los dias entre la fecha actual y la enviada para insertar el texto en el chat
         * @param {?} date fecha del mensaje
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.dayDifference = /**
         * Compara los dias entre la fecha actual y la enviada para insertar el texto en el chat
         * @param {?} date fecha del mensaje
         * @return {?}
         */
        function (date) {
            /** @type {?} */
            var temDate = this.date.differenceDaysText(new Date(date));
            return temDate !== undefined ? temDate : '';
        };
        /**
         * Validamos si el tipo de mensaje es enviado
         * @param state estado actual del mensaje
         * @param messageType enviado o recibido
         * @param stateSearch tipo que se consulta
         */
        /**
         * Validamos si el tipo de mensaje es enviado
         * @param {?} state estado actual del mensaje
         * @param {?} messageType enviado o recibido
         * @param {?} stateSearch tipo que se consulta
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.messageState = /**
         * Validamos si el tipo de mensaje es enviado
         * @param {?} state estado actual del mensaje
         * @param {?} messageType enviado o recibido
         * @param {?} stateSearch tipo que se consulta
         * @return {?}
         */
        function (state, messageType, stateSearch) {
            if (state === stateSearch && messageType === EMessageType.sent) {
                return true;
            }
            return false;
        };
        /**
         * Insertamos el estilo al mensaje dependiendo el tipo del mensaje
         * @param messageType si es recibido o enviado
         */
        /**
         * Insertamos el estilo al mensaje dependiendo el tipo del mensaje
         * @param {?} messageType si es recibido o enviado
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.chooseStyle = /**
         * Insertamos el estilo al mensaje dependiendo el tipo del mensaje
         * @param {?} messageType si es recibido o enviado
         * @return {?}
         */
        function (messageType) {
            if (messageType === EMessageType.sent) {
                return 'ngx-util-chat-right float-right arrow_box';
            }
            return 'ngx-util-chat-left float-left';
        };
        /**
         * Validaremos si debe mostrar el mensaje o no
         * @param message mensaje recibido
         */
        /**
         * Validaremos si debe mostrar el mensaje o no
         * @param {?} message mensaje recibido
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.validateMessage = /**
         * Validaremos si debe mostrar el mensaje o no
         * @param {?} message mensaje recibido
         * @return {?}
         */
        function (message) {
            if (message === '' || message === undefined || message === null) {
                return false;
            }
            return true;
        };
        /**
         * Validaremos si debe mostrar imagen o no
         * si mostramos una imagen pasaremos el Filelist a DataUrl
         * @param image imagen en el mensaje
         */
        /**
         * Validaremos si debe mostrar imagen o no
         * si mostramos una imagen pasaremos el Filelist a DataUrl
         * @param {?} message
         * @return {?}
         */
        ChatDetailMessageComponent.prototype.validateImage = /**
         * Validaremos si debe mostrar imagen o no
         * si mostramos una imagen pasaremos el Filelist a DataUrl
         * @param {?} message
         * @return {?}
         */
        function (message) {
            if (message.img === '' || message.img === undefined || message.img === null) {
                return false;
            }
            if (typeof (message.img) !== 'string') {
                if (message.imgUrl === undefined) {
                    this.messageImageUrl(message.img, message);
                }
            }
            else {
                message.imgUrl = message.img;
            }
            return true;
        };
        /**
         * Parseara el data enviado a una url
         * @param image Ruta de la image o el archivo de la imagen
         * @returns la imagen
         */
        /**
         * Parseara el data enviado a una url
         * @param {?} image Ruta de la image o el archivo de la imagen
         * @param {?} message
         * @return {?} la imagen
         */
        ChatDetailMessageComponent.prototype.messageImageUrl = /**
         * Parseara el data enviado a una url
         * @param {?} image Ruta de la image o el archivo de la imagen
         * @param {?} message
         * @return {?} la imagen
         */
        function (image, message) {
            if (image) {
                /** @type {?} */
                var mimeType = image.type;
                if (mimeType.match(/image\/*/) == null) {
                    return;
                }
                /** @type {?} */
                var reader = new FileReader();
                reader.onload = (/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) {
                    message.imgUrl = e.target.result;
                });
                reader.readAsDataURL(image);
            }
        };
        ChatDetailMessageComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-detail-message',
                        template: "<div id=\"message_{{i}}\" class=\"col-12\" class=\"ngx-util-detail-message\" *ngFor=\"let item of messages; let i=index \">\n    <div class=\"container-fluid\">\n      <div class=\"row\" *ngIf=\"dayLine(item.date,i)\">\n        <div class=\"w-100 ngx-util-chat-linea\">\n          <span class=\"ngx-util-chat-linea-span\">\n            {{dayDifference(item.date)}}\n          </span>\n        </div>\n      </div>\n    </div>\n    <div class=\"container-fluid\"  >\n      <div [ngClass]=\"chooseStyle(item.messageType)\">\n        <div *ngIf=\"validateImage(item)\">\n          <img src=\"{{item.imgUrl}}\" alt=\"Message\" class=\"img-message\">\n        </div>\n        <div *ngIf=\"validateMessage(item.message)\" class=\"message\">{{item.message}}</div>\n        <div class=\"hour\">{{item.hour}}\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.sent )\"\n            class=\"ngx-util-msg-sent\">\n            <em class=\"fa fa-check\"></em>\n          </span>\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.received)\"\n            class=\"ngx-util-msg-received\">\n            <em class=\"fa fa-check\"></em>\n            <em class=\"fa fa-check\"></em>\n          </span>\n          <span *ngIf=\"messageState(item.messageState, item.messageType, EMessageState.read )\"\n            class=\"ngx-util-msg-read\">\n            <em class=\"fa fa-check\"></em>\n            <em class=\"fa fa-check\"></em>\n          </span>\n        </div>\n      </div>\n    </div>\n  </div>",
                        styles: [".ngx-util-detail-message{background:inherit;display:flow-root}.ngx-util-chat-linea{position:relative;text-align:center;overflow:hidden;font-size:.87rem;margin:.93rem 3.125rem;text-transform:capitalize;color:#9e9e9e}.ngx-util-chat-linea::before{background:#e0e3e4;content:\"\";height:.0625rem;right:50%;margin-right:2.5rem;position:absolute;top:50%;width:100%}.ngx-util-chat-linea::after{background:#e0e3e4;content:\"\";height:.0625rem;left:50%;margin-left:2.5rem;position:absolute;top:50%;width:100%}.ngx-util-chat-right{background:#e7b723;padding:.3125rem .9375rem;border-radius:.25rem;display:inline-block;position:relative;margin-bottom:.3125rem;word-wrap:break-word;max-width:60%;color:#fff;text-align:right}.ngx-util-chat-left{background:#fff;padding:.3125rem .9375rem;border-radius:.25rem;display:inline-block;position:relative;margin-bottom:.3125rem;word-wrap:break-word;max-width:60%;color:#fff;text-align:left}.ngx-util-chat-right .message{color:#fff;margin:0;opacity:1;font-size:.875rem}.img-message{height:10rem;width:auto}.ngx-util-chat-right .hour{color:rgba(255,255,255,.5);opacity:1;font-size:.8125rem}.ngx-util-chat-left .message{color:#324148;margin:0;opacity:1;font-size:.875rem}.ngx-util-chat-left .hour{color:rgba(50,65,72,.4);opacity:1;font-size:.8125rem}.ngx-util-msg-read{color:#fff}"]
                    }] }
        ];
        /** @nocollapse */
        ChatDetailMessageComponent.ctorParameters = function () { return []; };
        ChatDetailMessageComponent.propDecorators = {
            messages: [{ type: core.Input }]
        };
        return ChatDetailMessageComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente que trabaja sobre ngx-perfect-scrollbar
     */
    var PerfectScrollComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function PerfectScrollComponent() {
            /**
             * Variables de configuarion
             */
            this.config = {};
        }
        /**
         * Despues de verificar que carge el viewchild mueve el scroll a la parte deseada
         */
        /**
         * Despues de verificar que carge el viewchild mueve el scroll a la parte deseada
         * @return {?}
         */
        PerfectScrollComponent.prototype.ngAfterViewChecked = /**
         * Despues de verificar que carge el viewchild mueve el scroll a la parte deseada
         * @return {?}
         */
        function () {
            if (this.position !== undefined && this.elementName === undefined) {
                this.calculatePosition(this.position);
            }
            else if (this.elementName !== undefined) {
                this.scrollToElement();
            }
        };
        /**
         * Segun las coordenadas indica al scroll que accion realizar
         * @param position Array con el eje x y
         */
        /**
         * Segun las coordenadas indica al scroll que accion realizar
         * @param {?} position Array con el eje x y
         * @return {?}
         */
        PerfectScrollComponent.prototype.calculatePosition = /**
         * Segun las coordenadas indica al scroll que accion realizar
         * @param {?} position Array con el eje x y
         * @return {?}
         */
        function (position) {
            if (position[0] === EScrollPosition.start) {
                this.scrollToLeft();
            }
            if (position[0] === EScrollPosition.end) {
                this.scrollToRight();
            }
            if (position[1] === EScrollPosition.start) {
                this.scrollToTop();
            }
            if (position[1] === EScrollPosition.end) {
                this.scrollToBottom();
            }
            if (position[0] > 0 && position[1] > 0) {
                this.scrollToXY(position[0], position[1]);
            }
        };
        /**
         * Mover el scroll a un posicion
         * @param x Eje x
         * @param y Eje y
         */
        /**
         * Mover el scroll a un posicion
         * @param {?} x Eje x
         * @param {?} y Eje y
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToXY = /**
         * Mover el scroll a un posicion
         * @param {?} x Eje x
         * @param {?} y Eje y
         * @return {?}
         */
        function (x, y) {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollTo(x, y, 500);
            }
        };
        /**
         * mover el scroll a la parte superio
         */
        /**
         * mover el scroll a la parte superio
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToTop = /**
         * mover el scroll a la parte superio
         * @return {?}
         */
        function () {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollToTop();
            }
        };
        /**
         * mover el scroll a la izquierda
         */
        /**
         * mover el scroll a la izquierda
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToLeft = /**
         * mover el scroll a la izquierda
         * @return {?}
         */
        function () {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollToLeft();
            }
        };
        /**
         * Mover el scroll a  la derecha
         */
        /**
         * Mover el scroll a  la derecha
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToRight = /**
         * Mover el scroll a  la derecha
         * @return {?}
         */
        function () {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollToRight();
            }
        };
        /**
         * mover el scroll al final
         */
        /**
         * mover el scroll al final
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToBottom = /**
         * mover el scroll al final
         * @return {?}
         */
        function () {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollToBottom();
            }
        };
        /**
         * mover el scroll al elemento
         */
        /**
         * mover el scroll al elemento
         * @return {?}
         */
        PerfectScrollComponent.prototype.scrollToElement = /**
         * mover el scroll al elemento
         * @return {?}
         */
        function () {
            if (this.componentRef !== undefined && this.componentRef.directiveRef) {
                this.componentRef.directiveRef.scrollToElement('#' + this.elementName);
            }
        };
        /**
         * Al movernos sobre el div
         * @param event scroll
         */
        /**
         * Al movernos sobre el div
         * @param {?} event scroll
         * @return {?}
         */
        PerfectScrollComponent.prototype.onScrollEvent = /**
         * Al movernos sobre el div
         * @param {?} event scroll
         * @return {?}
         */
        function (event) {
            event.preventDefault();
            event.stopPropagation();
        };
        PerfectScrollComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-perfect-scroll',
                        template: "<perfect-scrollbar class=\"scroll-container window__list\" fxFlex=\"auto\" [config]=\"config\" [scrollIndicators]=\"true\"\n  (psXReachEnd)=\"onScrollEvent($event)\" (psYReachEnd)=\"onScrollEvent($event)\" (psXReachStart)=\"onScrollEvent($event)\"\n  (psYReachStart)=\"onScrollEvent($event)\">\n  <div class=\"scrollable-content\">\n    <ng-content></ng-content>\n  </div>\n</perfect-scrollbar>",
                        styles: [".scroll-container{position:relative}.scrollable-content{padding:16px;margin:0}"]
                    }] }
        ];
        /** @nocollapse */
        PerfectScrollComponent.ctorParameters = function () { return []; };
        PerfectScrollComponent.propDecorators = {
            componentRef: [{ type: core.ViewChild, args: [ngxPerfectScrollbar.PerfectScrollbarComponent, { static: false },] }],
            position: [{ type: core.Input }],
            elementName: [{ type: core.Input }]
        };
        return PerfectScrollComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo que contiene un scroll perfecto para usar en nuestros div estilizado
     * @type {?}
     */
    var DEFAULT_PERFECT_SCROLLBAR_CONFIG = {
        wheelPropagation: true
    };
    var ɵ0 = DEFAULT_PERFECT_SCROLLBAR_CONFIG;
    var NgxUtilitarioPerfectScrollModule = /** @class */ (function () {
        function NgxUtilitarioPerfectScrollModule() {
        }
        NgxUtilitarioPerfectScrollModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [PerfectScrollComponent],
                        imports: [
                            common.CommonModule,
                            ngxPerfectScrollbar.PerfectScrollbarModule
                        ],
                        exports: [
                            PerfectScrollComponent,
                            ngxPerfectScrollbar.PerfectScrollbarModule
                        ],
                        providers: [
                            {
                                provide: ngxPerfectScrollbar.PERFECT_SCROLLBAR_CONFIG,
                                useValue: ɵ0
                            }
                        ]
                    },] }
        ];
        return NgxUtilitarioPerfectScrollModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente en el cual podremos visualizar una imagen
     */
    var ChatDetailPreviewComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function ChatDetailPreviewComponent() {
            /**
             * Variable en la cual se guardara el titulo de la vista previa
             */
            this.title = 'Vista Previa';
            /**
             * Evento indicando que cierre la ventana
             */
            this.close = new core.EventEmitter();
            /**
             * arreglo en el cual guardaremos las imagenes seleccionadas
             */
            this.imgUrls = [];
        }
        /**
         * 1.- si cambian los archivos mostrar el primer archivo
         * @param changes Si cambia files
         */
        /**
         * 1.- si cambian los archivos mostrar el primer archivo
         * @param {?} changes Si cambia files
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.ngOnChanges = /**
         * 1.- si cambian los archivos mostrar el primer archivo
         * @param {?} changes Si cambia files
         * @return {?}
         */
        function (changes) {
            if (changes.files) {
                this.finalFiles = changes.files.currentValue;
                this.previewFiles();
                this.previewFile();
            }
        };
        /**
         * Metodo el cual mostrara la imagen seleccionada o la primera por defecto
         * @param index imagen a mostrar
         */
        /**
         * Metodo el cual mostrara la imagen seleccionada o la primera por defecto
         * @param {?=} imgUrl
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.previewFile = /**
         * Metodo el cual mostrara la imagen seleccionada o la primera por defecto
         * @param {?=} imgUrl
         * @return {?}
         */
        function (imgUrl) {
            var _this = this;
            if (imgUrl !== undefined) {
                this.imgUrl = imgUrl;
                return;
            }
            if (this.finalFiles) {
                if (this.finalFiles.length <= 0) {
                    return;
                }
                /** @type {?} */
                var mimeType = this.finalFiles[0].type;
                if (mimeType.match(/image\/*/) == null) {
                    return;
                }
                /** @type {?} */
                var reader_1 = new FileReader();
                // this.imagePath = this.finalFiles;
                reader_1.readAsDataURL(this.finalFiles[0]);
                reader_1.onload = (/**
                 * @return {?}
                 */
                function () {
                    _this.imgUrl = reader_1.result;
                });
            }
        };
        /**
         * Metodo que permitira visualizar todas las imagenes
         */
        /**
         * Metodo que permitira visualizar todas las imagenes
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.previewFiles = /**
         * Metodo que permitira visualizar todas las imagenes
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.finalFiles) {
                if (this.finalFiles.length === 0) {
                    return;
                }
                /** @type {?} */
                var mimeType = this.finalFiles[0].type;
                if (mimeType.match(/image\/*/) == null) {
                    return;
                }
                this.imgUrls = [];
                Array.from(this.finalFiles).forEach((/**
                 * @param {?} file
                 * @return {?}
                 */
                function (file) {
                    /** @type {?} */
                    var readerGallery = new FileReader();
                    readerGallery.onload = (/**
                     * @param {?} e
                     * @return {?}
                     */
                    function (e) {
                        _this.imgUrls.push(e.target.result);
                    });
                    readerGallery.readAsDataURL(file);
                }));
            }
        };
        /**
         * Devulve la longitud de archivos en finalFiles o cero en caso sea undefined
         */
        /**
         * Devulve la longitud de archivos en finalFiles o cero en caso sea undefined
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.filesCount = /**
         * Devulve la longitud de archivos en finalFiles o cero en caso sea undefined
         * @return {?}
         */
        function () {
            if (this.finalFiles === undefined) {
                return 0;
            }
            return this.finalFiles.length;
        };
        /**
         * Emite un evento para cerrar vista
         */
        /**
         * Emite un evento para cerrar vista
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.closePreview = /**
         * Emite un evento para cerrar vista
         * @return {?}
         */
        function () {
            this.close.emit(true);
        };
        /**
         * Agregaremos mas imagenes a las imagenes mostradas actualmente
         */
        /**
         * Agregaremos mas imagenes a las imagenes mostradas actualmente
         * @param {?} images
         * @return {?}
         */
        ChatDetailPreviewComponent.prototype.addImage = /**
         * Agregaremos mas imagenes a las imagenes mostradas actualmente
         * @param {?} images
         * @return {?}
         */
        function (images) {
        };
        ChatDetailPreviewComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-chat-detail-preview',
                        template: "<!--Titulo del componente-->\n<div class=\"w-100 ngx-util-preview-title\">\n  <em class=\"fa fa-times ngx-util-em-action\" (click)=\"closePreview()\"></em> {{title}}\n</div>\n<!--div donde mostrara la imagen  seleccionada e insercion del texto-->\n<div class=\"ngx-util-preview-body\">\n  <img src=\"{{imgUrl}}\" alt=\"img preview\" height=\"200\" *ngIf=\"imgUrl\">\n</div>\n<!--todos los archivos seleccionados y la posibilidad de a\u00F1adir mas archivos-->\n<div class=\"ngx-util-preview-files\">\n  <div class=\"row no-margin\">\n    <ngx-utilitario-perfect-scroll class=\"col-10\">\n      <div class=\"ngx-util-preview-all-files\">\n        <div *ngFor=\"let index of filesCount() | numberToArray\" class=\"ngx-util-preview-files-item\">\n          <img src=\"{{imgUrls[index]}}\" alt=\"img preview\" height=\"100\" (click)=\"previewFile(imgUrls[index])\">\n          <!-- <div style=\"height: 100px; width: 100px; background:red; border: 1px solid black\"></div> -->\n        </div>\n      </div>\n    </ngx-utilitario-perfect-scroll>\n    <input class=\"ngx-util-input-file\" type=\"file\" accept=\"image/*\" #file (change)=\"addImage($event)\" multiple>\n    <div class=\"ngx-util-preview-files-add\" (click)=\"file.click()\"> \n      <em class=\"fa fa-plus ngx-util-preview-files-add-icon\"></em> Agregar Imagenes\n    </div>\n  </div>\n</div>",
                        styles: [".ngx-util-preview-title{background:#e7b723;color:#fff;padding:.9375rem 1.25rem;font-size:1rem}.ngx-util-em-action{padding:.625rem .875rem;transition:.2s ease-in-out;-webkit-transform-style:preserve-3d;transform-style:preserve-3d}.ngx-util-em-action:hover{background:rgba(255,255,255,.2);outline:0!important;text-decoration:none;border-radius:50%}.ngx-util-preview-body{text-align:center;padding:18px 0}.ngx-util-preview-files{height:6.875rem;padding:10px 5px;background:#dddde0}.ngx-util-preview-all-files{display:flex}.ngx-util-preview-files-item{float:left;flex:0 0 16.666667%;max-width:16.666667%;text-align:center;margin:0 .3125rem}.ngx-util-preview-files-item img{flex:0 0 90%;max-width:90%;height:-webkit-fill-available}.ngx-util-preview-files-add{flex:0 0 14%;max-width:14%;font-size:14px;color:#e7b723;text-align:center;padding:.5rem 3%!important;background:#fff;margin-left:.625rem;cursor:pointer}.ngx-util-preview-files-add-icon{display:block;font-weight:900;font-size:xx-large}"]
                    }] }
        ];
        /** @nocollapse */
        ChatDetailPreviewComponent.ctorParameters = function () { return []; };
        ChatDetailPreviewComponent.propDecorators = {
            title: [{ type: core.Input }],
            files: [{ type: core.Input }],
            close: [{ type: core.Output }]
        };
        return ChatDetailPreviewComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo Chat el cual contiene las partes necesarias para el correcto funcinamiento de un chat
     */
    var NgxUtilitarioChatModule = /** @class */ (function () {
        function NgxUtilitarioChatModule() {
        }
        NgxUtilitarioChatModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [
                            ChatComponent,
                            ChatSearchComponent,
                            ChatListComponent,
                            ChatListDetailComponent,
                            ChatDetailComponent,
                            ChatDetailAddComponent,
                            ChatDetailMessageComponent,
                            ChatDetailPreviewComponent,
                        ],
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            NgxUtilitarioFormstModule,
                            NgxUtilitarioPerfectScrollModule,
                            NgxUtilitarioPipesModule,
                            material.MatIconModule
                        ],
                        exports: [
                            ChatComponent,
                            ChatSearchComponent,
                            ChatListComponent,
                            ChatListDetailComponent,
                            ChatDetailComponent,
                            ChatDetailAddComponent,
                            ChatDetailMessageComponent,
                            ChatDetailPreviewComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioChatModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Mustra un menu dot
     */
    var MenuDotComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function MenuDotComponent() {
            /**
             * Opciones de un menu
             */
            this.menu1 = {
                icon: 'block',
                nombre: 'bloqueo',
                text: 'Ver Chats Bloqueados'
            };
            /**
             * Opciones de un menu
             */
            this.menu2 = {
                icon: 'block',
                nombre: 'bloqueo',
                text: 'block 2'
            };
            /**
             * menu a mostrar
             */
            this.menus = [this.menu1, this.menu2];
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        MenuDotComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Al hacer click en un elemento retornara el nombre del menu que realizo click
         */
        /**
         * Al hacer click en un elemento retornara el nombre del menu que realizo click
         * @param {?} item
         * @return {?}
         */
        MenuDotComponent.prototype.menuClick = /**
         * Al hacer click en un elemento retornara el nombre del menu que realizo click
         * @param {?} item
         * @return {?}
         */
        function (item) {
            console.log(item);
        };
        MenuDotComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-menu-dot',
                        template: "<button mat-icon-button [matMenuTriggerFor]=\"menuDot\">\n  <mat-icon>more_vert</mat-icon>\n</button>\n<mat-menu #menuDot=\"matMenu\">\n  <button mat-menu-item *ngFor=\"let item of menus\" (click)=\"menuClick(item)\" >\n    <mat-icon>{{item.icon}}</mat-icon>\n    <span>{{item.texto}}</span>\n  </button>\n</mat-menu>"
                    }] }
        ];
        /** @nocollapse */
        MenuDotComponent.ctorParameters = function () { return []; };
        return MenuDotComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioMenuModule = /** @class */ (function () {
        function NgxUtilitarioMenuModule() {
        }
        NgxUtilitarioMenuModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [MenuDotComponent],
                        imports: [
                            material.MatMenuModule,
                            material.MatIconModule,
                            common.CommonModule
                        ],
                        exports: [
                            MenuDotComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioMenuModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Card con titulo, subtitulo e icono
     */
    var CardsComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function CardsComponent() {
            /**
             * Icono a mostrar en el card
             */
            this.icono = 'fa fa-user';
            /**
             * Clase a aplicar al texto
             */
            this.classTexto = 'w-80 float-left';
            /**
             * Enviar el tamaño de columnas y el tamaño del icono
             */
            this.classIcono = 'w-20 fontSize2-5';
            /**
             * Color del icono a mostrar
             */
            this.color = '#000';
            /**
             * Enviar accion de click en el card
             */
            this.click = new core.EventEmitter();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        CardsComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Envia un evento si hace click en el card
         * @param $event Caracteristicas del evento click en el card
         */
        /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        CardsComponent.prototype.clickCard = /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        function ($event) {
            this.click.emit($event);
        };
        CardsComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-cards',
                        template: "<div class=\"cards\" (click)=\"clickCard($event)\">\r\n    <div [ngClass]=\"classTexto\">\r\n        <h2 class=\"cardsTitulo\">{{titulo}}</h2>\r\n        <h3 class=\"cardsSubtitulo\">{{subtitulo}}</h3>\r\n        <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n    </div>\r\n\r\n    <div [ngClass]=\"classIcono\">\r\n        <em class=\"{{icono}} float-right cardIcono\" [style.color]=\"color\"></em>\r\n    </div>\r\n</div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left}.cards:hover{background-color:rgba(0,0,0,.05)}.cardsTitulo{font-size:.75rem;font-weight:700;text-transform:uppercase;color:#595959;padding:1rem 0 0 1.2rem;margin:0}.cardsSubtitulo{color:#b0b0b0;font-size:1.5rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardIcono{padding:1rem .5rem .5rem 0}.classIcono{display:table-cell;width:auto}.fontSize2-5{font-size:2.5rem;padding-right:0}"]
                    }] }
        ];
        /** @nocollapse */
        CardsComponent.ctorParameters = function () { return []; };
        CardsComponent.propDecorators = {
            titulo: [{ type: core.Input }],
            subtitulo: [{ type: core.Input }],
            icono: [{ type: core.Input }],
            classTexto: [{ type: core.Input }],
            classIcono: [{ type: core.Input }],
            color: [{ type: core.Input }],
            click: [{ type: core.Output }]
        };
        return CardsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Card con titulo, descripcion, etiqueta, icono e imagen
     */
    var CardsImgTextComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function CardsImgTextComponent() {
            /**
             * Descripciòn a mostrar en el card
             */
            this.descripcion = 'afdasdf';
            /**
             * Etiqueta a mostrar en el card
             */
            this.etiqueta = 'etiqueta';
            /**
             * Imagen a mostrar en el card
             */
            this.imagen = './assets/test.jpg';
            /**
             * recibe el icono a usar
             */
            this.icono = 'fa fa-user';
            /**
             * Enviar el tamaño de columnas y el tamaño del icono
             */
            this.classTexto = 'w-80 float-left';
            /**
             * Clase para asignar al icono
             */
            this.classIcono = 'col-1 align-middle cardIcono';
            /**
             * Color del icono
             */
            this.color = '#000';
            /**
             * Altura del icono
             */
            this.height = '6.5rem';
            /**
             * Acccion click en el card
             */
            this.click = new core.EventEmitter();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        CardsImgTextComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Envia un evento si hace click en el card
         * @param $event Caracteristicas del evento click en el card
         */
        /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        CardsImgTextComponent.prototype.clickCard = /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        function ($event) {
            this.click.emit($event);
        };
        CardsImgTextComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-cards-img-text',
                        template: "<div class=\"row cards row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\r\n  <div class=\"col-2 float-left\">\r\n      <img class=\"cardsImagen\" src={{imagen}} alt=\"imagen de card cambiar a dinamico\" [style.height]=\"height\" />\r\n  </div>\r\n  <div class=\"col-9\">\r\n      <div [ngClass]=\"classTexto\">\r\n          <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\r\n          <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\r\n          <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\r\n          <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n      </div>\r\n  </div>\r\n  <div [ngClass]=\"classIcono\">\r\n      <em class=\"{{icono}} float-right cardIcono\"></em>\r\n  </div>\r\n</div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;-moz-box-shadow:0 1px 2px rgba(0,0,0,.2);-webkit-box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s;margin:10px 0}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}"]
                    }] }
        ];
        /** @nocollapse */
        CardsImgTextComponent.ctorParameters = function () { return []; };
        CardsImgTextComponent.propDecorators = {
            titulo: [{ type: core.Input }],
            descripcion: [{ type: core.Input }],
            etiqueta: [{ type: core.Input }],
            imagen: [{ type: core.Input }],
            icono: [{ type: core.Input }],
            classTexto: [{ type: core.Input }],
            classIcono: [{ type: core.Input }],
            color: [{ type: core.Input }],
            height: [{ type: core.Input }],
            click: [{ type: core.Output }]
        };
        return CardsImgTextComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Card con titulo, descripcion, etiqueta, icono y contenido
     */
    var CardsImgTextNdivComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function CardsImgTextNdivComponent() {
            /**
             * Descripciòn a mostrar en el card
             */
            this.descripcion = 'afdasdf';
            /**
             * Etiqueta a mostrar en el card
             */
            this.etiqueta = 'etiqueta';
            /**
             * Imagen a mostrar en el card
             */
            this.imagen = './assets/test.jpg';
            /**
             * Enviar el tamaño de columnas y el tamaño del icono
             */
            this.classTexto = 'float-left';
            /**
             * Color del icono
             */
            this.color = '#000';
            /**
             * Altura del icono
             */
            this.height = '6.5rem';
            /**
             * Contenido a mostrar dinamicamente
             */
            this.contenido = [];
            /**
             * Acccion click en el card
             */
            this.click = new core.EventEmitter();
        }
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        CardsImgTextNdivComponent.prototype.ngOnInit = /**
         * @ignore
         * @return {?}
         */
        function () {
        };
        /**
         * Envia un evento si hace click en el card
         * @param $event Caracteristicas del evento click en el card
         */
        /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        CardsImgTextNdivComponent.prototype.clickCard = /**
         * Envia un evento si hace click en el card
         * @param {?} $event Caracteristicas del evento click en el card
         * @return {?}
         */
        function ($event) {
            this.click.emit($event);
        };
        CardsImgTextNdivComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-cards-img-text-ndiv',
                        template: "<div class=\"cards row row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\r\n  <div class=\"col-2 float-left\">\r\n      <img class=\"cardsImagen\" src={{imagen}} alt=\"imagen de card cambiar a dinamico\" [style.height]=\"height\"/>\r\n  </div>\r\n  <div class=\"col-{{10 - contenido.length }} float-left\">\r\n      <div [ngClass]=\"classTexto\">\r\n          <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\r\n          <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\r\n          <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\r\n          <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\r\n      </div>\r\n  </div>\r\n  <div *ngFor=\"let item of contenido\" class=\"col-1 float-left center-middle\" [style.line-height]=\"height\">\r\n      <ng-content *ngIf=\"item==='content'\"></ng-content>\r\n      <span *ngIf=\"item!=='content'\">{{item}}</span>\r\n  </div>\r\n</div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;-moz-box-shadow:0 1px 2px rgba(0,0,0,.2);-webkit-box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill;padding-left:1.2rem}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}"]
                    }] }
        ];
        /** @nocollapse */
        CardsImgTextNdivComponent.ctorParameters = function () { return []; };
        CardsImgTextNdivComponent.propDecorators = {
            titulo: [{ type: core.Input }],
            descripcion: [{ type: core.Input }],
            etiqueta: [{ type: core.Input }],
            imagen: [{ type: core.Input }],
            classTexto: [{ type: core.Input }],
            color: [{ type: core.Input }],
            height: [{ type: core.Input }],
            contenido: [{ type: core.Input }],
            click: [{ type: core.Output }]
        };
        return CardsImgTextNdivComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Modulo el cual contiene componentes de cards
     */
    var NgxUtilitarioCardsModule = /** @class */ (function () {
        function NgxUtilitarioCardsModule() {
        }
        NgxUtilitarioCardsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [CardsComponent, CardsImgTextComponent, CardsImgTextNdivComponent],
                        imports: [
                            common.CommonModule
                        ],
                        exports: [
                            CardsComponent, CardsImgTextComponent, CardsImgTextNdivComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioCardsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Componente creado con la finalidad de mostrar un carousel utilizando ngx-own-carousel
     * para ser utilizado necesita estos estilos
     * "./node_modules/jquery/dist/jquery.min.js"
     * "./node_modules/owl.carousel/dist/owl.carousel.min.js"
     * "./node_modules/owl.carousel/dist/assets/owl.theme.green.min.css",
     *
     * se puede evitar eso si se incluye esto al scss principal
     * import "~owl.carousel/dist/assets/owl.carousel.css";
     * import "~owl.carousel/dist/assets/owl.theme.default.css";
     *
     * y este script
     * "./node_modules/jquery/dist/jquery.min.js"
     * "./node_modules/owl.carousel/dist/owl.carousel.min.js"
     */
    var CarouselComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function CarouselComponent(zone) {
            this.zone = zone;
        }
        /**
         * @return {?}
         */
        CarouselComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.owlCarouselOptions = {
                items: 3,
                dots: true,
                nav: true,
                navText: [' < prev ', ' next > '],
                navClass: ['', ''],
                autoplay: true,
                autoplayTimeout: 5000,
                autoplayHoverPause: false,
                loop: true,
                center: true,
                onTranslate: (/**
                 * @param {?} e
                 * @return {?}
                 */
                function (e) { return _this.zone.run((/**
                 * @return {?}
                 */
                function () { })); }),
            };
        };
        /**
         * Items a mostrar en el carrusel
         */
        /**
         * Items a mostrar en el carrusel
         * @param {?} items
         * @return {?}
         */
        CarouselComponent.prototype.setItems = /**
         * Items a mostrar en el carrusel
         * @param {?} items
         * @return {?}
         */
        function (items) {
            this.owlCarouselOptions.items = items;
        };
        /**
         * Si se desea mostrar dots dots
         */
        /**
         * Si se desea mostrar dots dots
         * @param {?} value
         * @return {?}
         */
        CarouselComponent.prototype.setDots = /**
         * Si se desea mostrar dots dots
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.owlCarouselOptions.dots = value;
        };
        /**
         * Si se muestra la navegacion
         */
        /**
         * Si se muestra la navegacion
         * @param {?} value
         * @return {?}
         */
        CarouselComponent.prototype.setNav = /**
         * Si se muestra la navegacion
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.owlCarouselOptions.nav = value;
        };
        /**
         * Si se desea cambiar el texto
         * @param text [' < prev ', ' next > ']
         */
        /**
         * Si se desea cambiar el texto
         * @param {?} text [' < prev ', ' next > ']
         * @return {?}
         */
        CarouselComponent.prototype.setNavText = /**
         * Si se desea cambiar el texto
         * @param {?} text [' < prev ', ' next > ']
         * @return {?}
         */
        function (text) {
            this.owlCarouselOptions.navText = text;
        };
        /**
         * Si se desea cambiar el texto
         * @param text  ['<img src=\'myprevimage.png\'>', '<img src=\'mynextimage.png\'>']
         */
        /**
         * Si se desea cambiar el texto
         * @param {?} text  ['<img src=\'myprevimage.png\'>', '<img src=\'mynextimage.png\'>']
         * @return {?}
         */
        CarouselComponent.prototype.setNavClass = /**
         * Si se desea cambiar el texto
         * @param {?} text  ['<img src=\'myprevimage.png\'>', '<img src=\'mynextimage.png\'>']
         * @return {?}
         */
        function (text) {
            this.owlCarouselOptions.navText = text;
        };
        /**
         * Set movimiento del carrusel
         */
        /**
         * Set movimiento del carrusel
         * @param {?} autoplay
         * @param {?=} autoplayTimeout
         * @param {?=} autoplayHoverPause
         * @return {?}
         */
        CarouselComponent.prototype.setAutoPlay = /**
         * Set movimiento del carrusel
         * @param {?} autoplay
         * @param {?=} autoplayTimeout
         * @param {?=} autoplayHoverPause
         * @return {?}
         */
        function (autoplay, autoplayTimeout, autoplayHoverPause) {
            this.owlCarouselOptions.autoplay = autoplay;
            if (autoplayTimeout !== undefined) {
                this.owlCarouselOptions.autoplayTimeout = autoplayTimeout;
            }
            if (autoplayHoverPause !== undefined) {
                this.owlCarouselOptions.autoplayHoverPause = autoplayHoverPause;
            }
        };
        /**
         * Autocompletar images
         */
        /**
         * Autocompletar images
         * @param {?} state
         * @return {?}
         */
        CarouselComponent.prototype.setLoop = /**
         * Autocompletar images
         * @param {?} state
         * @return {?}
         */
        function (state) {
            this.owlCarouselOptions.loop = state;
        };
        /**
         * Centrar images
         */
        /**
         * Centrar images
         * @param {?} state
         * @return {?}
         */
        CarouselComponent.prototype.setCenter = /**
         * Centrar images
         * @param {?} state
         * @return {?}
         */
        function (state) {
            this.owlCarouselOptions.center = state;
        };
        CarouselComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-image-carousel',
                        template: "<div style=\"text-align:center\">\n  <div class=\"owl-carousel owl-theme\" ngxUtilitarioOwlcarousel [owlOptions]=\"owlCarouselOptions\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        CarouselComponent.ctorParameters = function () { return [
            { type: core.NgZone }
        ]; };
        CarouselComponent.propDecorators = {
            owlCarouselOptions: [{ type: core.Input }]
        };
        return CarouselComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * Directiva para trabajar sobre owlCarousel
     */
    var OwlcarouselDirective = /** @class */ (function () {
        // private _items: any[];
        /**
         * @ignore
         */
        function OwlcarouselDirective(el) {
            this.$el = $(el.nativeElement);
        }
        /**
         * Inicializamos el carrusel owl
         */
        /**
         * Inicializamos el carrusel owl
         * @return {?}
         */
        OwlcarouselDirective.prototype.ngAfterViewChecked = /**
         * Inicializamos el carrusel owl
         * @return {?}
         */
        function () {
            this.initOwl();
        };
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        OwlcarouselDirective.prototype.ngOnDestroy = /**
         * @ignore
         * @return {?}
         */
        function () {
            this.destroyOwl();
        };
        /**
         * Inicialización del owl carrusel
         */
        /**
         * Inicialización del owl carrusel
         * @return {?}
         */
        OwlcarouselDirective.prototype.initOwl = /**
         * Inicialización del owl carrusel
         * @return {?}
         */
        function () {
            var _this = this;
            if (this.$el.find('.item').length &&
                typeof $.fn.owlCarousel === 'function' &&
                !this.$el.hasClass('owl-loaded')) {
                setTimeout((/**
                 * @return {?}
                 */
                function () {
                    _this.$el.owlCarousel((/** @type {?} */ (_this.owlOptions)));
                }), 0);
            }
        };
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        OwlcarouselDirective.prototype.destroyOwl = /**
         * @ignore
         * @return {?}
         */
        function () {
            if (this.$el) {
                this.$el.trigger('destroy.owl.carousel')
                    .removeClass('owl-loaded owl-hidden')
                    .find('.owl-stage:empty, .owl-item:empty')
                    .remove();
            }
        };
        /**
         * @ignore
         */
        /**
         * @ignore
         * @return {?}
         */
        OwlcarouselDirective.prototype.reInitOwl = /**
         * @ignore
         * @return {?}
         */
        function () {
            this.destroyOwl();
            this.initOwl();
        };
        OwlcarouselDirective.decorators = [
            { type: core.Directive, args: [{
                        selector: '[ngxUtilitarioOwlcarousel]'
                    },] }
        ];
        /** @nocollapse */
        OwlcarouselDirective.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        OwlcarouselDirective.propDecorators = {
            owlOptions: [{ type: core.Input }]
        };
        return OwlcarouselDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioImageModule = /** @class */ (function () {
        function NgxUtilitarioImageModule() {
        }
        NgxUtilitarioImageModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [CarouselComponent, OwlcarouselDirective],
                        imports: [
                            common.CommonModule,
                            ngxOwlCarousel.OwlModule
                        ],
                        exports: [CarouselComponent]
                    },] }
        ];
        return NgxUtilitarioImageModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var BarChartComponent = /** @class */ (function () {
        function BarChartComponent() {
            this.barChartOptions = {
                scaleShowVerticalLines: false,
                responsive: true
            };
            this.barChartType = 'bar';
            /**
             * Mostrar leyenda en la parte superior
             */
            this.barChartLegend = true;
            /**
             * Mostrar labels en el eje x
             */
            this.barChartLabels = undefined;
            /**
             * Data a mostrar en el grafico
             * example [{ data: [], label: ''}],
             */
            this.barChartData = undefined;
        }
        /**
         * @return {?}
         */
        BarChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        BarChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-bar-chart',
                        template: "<div>\n  <div style=\"display: block\" *ngIf=\"barChartLabels && barChartData\">\n    <canvas baseChart\n            [datasets]=\"barChartData\"\n            [labels]=\"barChartLabels\"\n            [options]=\"barChartOptions\"\n            [legend]=\"barChartLegend\"\n            [chartType]=\"barChartType\">\n    </canvas>\n  </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        BarChartComponent.ctorParameters = function () { return []; };
        BarChartComponent.propDecorators = {
            barChartLegend: [{ type: core.Input }],
            barChartLabels: [{ type: core.Input }],
            barChartData: [{ type: core.Input }]
        };
        return BarChartComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var LineChartComponent = /** @class */ (function () {
        function LineChartComponent() {
            /**
             * Propiedades en el eje x preconfigurado
             */
            this.lineChartOptions = {
                responsive: true,
                scales: {
                    yAxes: [
                        {
                            stacked: false,
                        }
                    ]
                }
            };
            /**
             * Color de las lineas en ese orden
             * si deseas las lines sin color define el color
             * example
             * [
             * {
             *   borderColor: 'black',
             *   backgroundColor: 'rgba(255,0,0,0.3)',
             * },
             * ];
             */
            this.lineChartColors = [];
            this.lineChartLegend = true;
            this.lineChartType = 'line';
            this.lineChartPlugins = [];
        }
        /**
         * @return {?}
         */
        LineChartComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        LineChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-line-chart',
                        template: "<div>\n  <div style=\"display: block\" *ngIf=\"lineChartLabels && lineChartData\">\n    <canvas baseChart \n      [datasets]=\"lineChartData\" \n      [labels]=\"lineChartLabels\" \n      [options]=\"lineChartOptions\"\n      [colors]=\"lineChartColors\" \n      [legend]=\"lineChartLegend\" \n      [chartType]=\"lineChartType\" \n      [plugins]=\"lineChartPlugins\">>\n    </canvas>\n  </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        LineChartComponent.ctorParameters = function () { return []; };
        LineChartComponent.propDecorators = {
            lineChartData: [{ type: core.Input }],
            lineChartLabels: [{ type: core.Input }],
            lineChartOptions: [{ type: core.Input }],
            lineChartColors: [{ type: core.Input }]
        };
        return LineChartComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PolarAreaChartComponent = /** @class */ (function () {
        /**
         * @ignore
         */
        function PolarAreaChartComponent() {
            /**
             * Leyenda a mostrar
             */
            this.polarAreaLegend = true;
            /**
             * Tipo de grafica a mostrar
             */
            this.polarAreaChartType = 'polarArea';
        }
        PolarAreaChartComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ngx-utilitario-polar-area-chart',
                        template: "<div>\n  <div style=\"display: block;\" *ngIf=\"polarAreaChartLabels && polarAreaChartData\">\n    <canvas baseChart \n      [data]=\"polarAreaChartData\" \n      [labels]=\"polarAreaChartLabels\" \n      [legend]=\"polarAreaLegend\"\n      [chartType]=\"polarAreaChartType\">\n    </canvas>\n  </div>\n</div>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        PolarAreaChartComponent.ctorParameters = function () { return []; };
        PolarAreaChartComponent.propDecorators = {
            polarAreaChartLabels: [{ type: core.Input }],
            polarAreaChartData: [{ type: core.Input }],
            polarAreaLegend: [{ type: core.Input }]
        };
        return PolarAreaChartComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioGraphicsModule = /** @class */ (function () {
        function NgxUtilitarioGraphicsModule() {
        }
        NgxUtilitarioGraphicsModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [BarChartComponent, LineChartComponent, PolarAreaChartComponent],
                        imports: [
                            common.CommonModule,
                            ng2Charts.ChartsModule
                        ],
                        exports: [
                            BarChartComponent,
                            LineChartComponent,
                            PolarAreaChartComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioGraphicsModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioRcltModule = /** @class */ (function () {
        function NgxUtilitarioRcltModule() {
        }
        NgxUtilitarioRcltModule.decorators = [
            { type: core.NgModule, args: [{
                        declarations: [],
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule,
                            platformBrowser.BrowserModule,
                            animations.BrowserAnimationsModule,
                            material.MatButtonModule,
                            angularFontAwesome.AngularFontAwesomeModule,
                            NgxUtilitarioFormstModule,
                            NgxUtilitarioChatModule,
                            NgxUtilitarioMenuModule,
                            NgxUtilitarioCardsModule,
                            NgxUtilitarioDynamicModule,
                            NgxUtilitarioGraphicsModule,
                            NgxUtilitarioIconsModule,
                            NgxUtilitarioModalModule,
                            NgxUtilitarioPerfectScrollModule,
                            NgxUtilitarioPipesModule,
                            NgxUtilitarioImageModule
                        ],
                        exports: []
                    },] }
        ];
        return NgxUtilitarioRcltModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EChatState = {
        /**
         * Si estoy conectado al chat
         */
        online: 1,
        /**
         * Si estoy desconectado al chat
         */
        offline: 0,
    };
    EChatState[EChatState.online] = 'online';
    EChatState[EChatState.offline] = 'offline';

    exports.DynamicComponentService = DynamicComponentService;
    exports.EChatLock = EChatLock;
    exports.EChatState = EChatState;
    exports.EMessageState = EMessageState;
    exports.EMessageType = EMessageType;
    exports.Fecha = Fecha;
    exports.NgxUtilitarioCardsModule = NgxUtilitarioCardsModule;
    exports.NgxUtilitarioChatModule = NgxUtilitarioChatModule;
    exports.NgxUtilitarioDynamicModule = NgxUtilitarioDynamicModule;
    exports.NgxUtilitarioFormstModule = NgxUtilitarioFormstModule;
    exports.NgxUtilitarioGraphicsModule = NgxUtilitarioGraphicsModule;
    exports.NgxUtilitarioIconsModule = NgxUtilitarioIconsModule;
    exports.NgxUtilitarioImageModule = NgxUtilitarioImageModule;
    exports.NgxUtilitarioMenuModule = NgxUtilitarioMenuModule;
    exports.NgxUtilitarioModalModule = NgxUtilitarioModalModule;
    exports.NgxUtilitarioPerfectScrollModule = NgxUtilitarioPerfectScrollModule;
    exports.NgxUtilitarioPipesModule = NgxUtilitarioPipesModule;
    exports.NgxUtilitarioRcltModule = NgxUtilitarioRcltModule;
    exports.ɵa = InputComponent;
    exports.ɵb = InputSearchComponent;
    exports.ɵc = ChatComponent;
    exports.ɵd = ChatSearchComponent;
    exports.ɵe = ChatListComponent;
    exports.ɵf = ChatListDetailComponent;
    exports.ɵg = ChatDetailComponent;
    exports.ɵh = ChatDetailAddComponent;
    exports.ɵi = ChatDetailMessageComponent;
    exports.ɵj = ChatDetailPreviewComponent;
    exports.ɵk = PerfectScrollComponent;
    exports.ɵl = HighlightPipe;
    exports.ɵm = NumberToArrayPipe;
    exports.ɵn = MenuDotComponent;
    exports.ɵo = CardsComponent;
    exports.ɵp = CardsImgTextComponent;
    exports.ɵq = CardsImgTextNdivComponent;
    exports.ɵr = BarChartComponent;
    exports.ɵs = LineChartComponent;
    exports.ɵt = PolarAreaChartComponent;
    exports.ɵu = RepeatIconComponent;
    exports.ɵv = ModalComponent;
    exports.ɵw = ModalService;
    exports.ɵx = CarouselComponent;
    exports.ɵy = OwlcarouselDirective;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ngx-utilitario-rclt.umd.js.map
