import { ElementRef, AfterViewChecked, OnDestroy } from '@angular/core';
import { IOwlcarouselOptions } from '../dto/iowlcarousel-options';
/**
 * Directiva para trabajar sobre owlCarousel
 */
export declare class OwlcarouselDirective implements AfterViewChecked, OnDestroy {
    /**
     * Obtenemos el div con las imagenes
     */
    $el: any;
    /**
     * Las opciones que tiene nuestro carrusel
     */
    owlOptions: IOwlcarouselOptions;
    /**
     * @ignore
     */
    constructor(el: ElementRef);
    /**
     * Inicializamos el carrusel owl
     */
    ngAfterViewChecked(): void;
    /**
     * @ignore
     */
    ngOnDestroy(): void;
    /**
     * Inicialización del owl carrusel
     */
    initOwl(): void;
    /**
     * @ignore
     */
    destroyOwl(): void;
    /**
     * @ignore
     */
    reInitOwl(): void;
}
